/*************************************************************************/
/*
 *  Inhalt           : Universeller Formelauswerter
 *  Version             : 1.03
 *  Projekt          : init: Zeitenbestimmung beim APG
 *  Programmierer    : Horst Hogenkamp / Sven Goethel
 *  Erstellungsdatum : 28. Juni 1994
 *  Aenderungsdatum  : 8.8.1994
 *  Datei            : $RCSfile: calc.h  $
 *  Verzeichnis      : $Source: e:/sven/prj/imos/calc/rcs/calc.h  $
 *  Dokumentation    :
 *
 *  1994 (C) Copyright Dr.-Ing.F.Prekwinkel GmbH
 *                     D-32052 Herford, Germany
 *
 * $Log: calc.h  $
 * Revision 2.26  1995/06/06 08:48:21  Sven_Goethel_DFP
 * ok
 * Revision 2.25  1995/06/06 08:20:18  Sven_Goethel_DFP
 * lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
 * Revision 2.24  1995/04/07 11:35:00  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:33  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:03  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:02  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:39:18  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:07:00  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.4  1995/01/30 08:17:16  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.3  1995/01/27 17:44:47  Sven_Goethel
 * break - 
 * Revision 1.2  1994/12/16 16:53:53  Sven_Goethel
 * *** empty log message ***
 * Revision 1.1  1994/12/16 16:52:02  Sven_Goethel
 * Initial revision
 *
 */

/* Historie:
   --------
************ ************ ************ $Log: calc.h  $
************ ************ ************ Revision 2.26  1995/06/06 08:48:21  Sven_Goethel_DFP
************ ************ ************ ok
************ ************ ************ Revision 2.25  1995/06/06 08:20:18  Sven_Goethel_DFP
************ ************ ************ lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
************ ************ ************ Revision 2.24  1995/04/07 11:35:00  Sven_Goethel_DFP
************ ************ ************ t_string wieder zurueck zu StrClass
************ ************ ************ Alles angepasst fuer Horts
************ ************ ************ ( aehh Horst . )
************ ************ ************ Wenn __SHOW_CALC__ definiert ist,
************ ************ ************ so werden Zeichen auf stderr gedruckt bei :
************ ************ ************   PARSEN der DATEI
************ ************ ************   INTERPRETIEREN der DATENSTRUKTUR
************ ************ ************ und alles fuer Calculator NEU und OLD
************ ************ ************ Revision 2.22  1995/04/05 07:45:33  Sven_Goethel_DFP
************ ************ ************ Alle Fehler behoben ..
************ ************ ************ getestet mit und ohne __OLD_INTERPRETE__ !
************ ************ ************ Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
************ ************ ************ hinzugekommen.
************ ************ ************ Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
************ ************ ************   bei return innerhalb verschachtelter Bloecke wurde der 
************ ************ ************   Block zaehler nicht wieder zureuckgesetzt !!!
************ ************ ************ Revision 2.21  1995/04/05 02:00:03  Sven_Goethel_DFP
************ ************ ************ profekt-pflege nun mit KornShell-Sripts
************ ************ ************ Revision 2.2  1995/04/05 01:48:02  Sven_Goethel_DFP
************ ************ ************ __Mem_Free fehler beseitigt
************ ************ ************ Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
************ ************ ************ den delete operator verwendet.
************ ************ ************ Es muss aber der delete[] operator verwendet werden :
************ ************ ************   int *p=new int[100];
************ ************ ************   delete p; // Error !
************ ************ ************   delete[] p; // Ok !
************ ************ ************ Revision 2.1  1995/04/01 02:39:18  Sven_Goethel_DFP
************ ************ ************ Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
************ ************ ************ Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
************ ************ ************ existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
************ ************ ************ Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
************ ************ ************ Revision 1.6  1995/02/28 15:07:00  Sven_Goethel_WPP
************ ************ ************ source ist nun mit borland c++ version 4.0
************ ************ ************ und mit watcom c++ version 10.0 zu uebersetzen !!!!
************ ************ ************ Revision 1.4  1995/01/30 08:17:16  Sven_Goethel
************ ************ ************ 1st full implemented & checked version
************ ************ ************ Revision 1.3  1995/01/27 17:44:47  Sven_Goethel
************ ************ ************ break - 
************ ************ ************ Revision 1.2  1994/12/16 16:53:53  Sven_Goethel
************ ************ ************ *** empty log message ***
************ ************ ************ Revision 1.1  1994/12/16 16:52:02  Sven_Goethel
************ ************ ************ Initial revision
 * Revision 1.2  1994/08/08  15:49:22  sven
 * Leerzeile gloescht
 *
 * Revision 1.1  1994/08/08  15:46:30  sven
 * Initial revision
************ ************ ************ (Zeiten alle in UTC) */
/* Beispiele:
   ----------
    {
    Calculator calc;
    calc.Declare("real eps = 0.001");
    calc.DeclareReal("x", 0.0);
    calc.SetReal("x", 4711*calc.GetReal("eps")-1);
    calc.Interprete(fd=fopen("SETTINGS.CFG","r"));
    if (calc.GetAndClearErrorState())
        ERROR_MESSAGE();
    calc.Reset();
    // Neubeginn moeglich
    }
*/
/*************************************************************************/


#ifndef _CALC_H
  #define _CALC_H

  #include "myyyscan.h"
  #include "lex_yy.hpp"
  #include "calc_y.h"

  class Calculator : public yy_parse 
	{
		public:
			enum Error { NO_ERR, VAR_GET_ERR, VAR_SET_ERR, VAR_TYP_ERR,
									 STR_MALLOC_ERR,
									 VAR_DECLARE_ERR, INTERPRETE_ERR, EXPR_FILE_ERR,
									 WRONG_ERR_NUMBER
								 };

			Calculator () ;

			void         Declare(const char *Expression);
			void         DeclareReal(const char *VarName, double Wert=0);
			void         SetReal(const char *VarName, double Wert);
			double       GetReal(const char *VarName);
			double       GetRealExpr(const char *Expression);
			void         DeclareString(const char *VarName, const char *Wert=NULL);
			void         SetString(const char *VarName, const char *Wert);

								   // GetStringCopy liefert eine Kopie mit malloc !!!!!!
                   // rather old, 
									 // but still a member-function because of compatibility ... :
			char         *GetStringCopy(const char *VarName);

                   // rather old, 
									 // but still a member-function because of compatibility ... :
			char   			 *GetString(const char *VarName);

			//           const char   *GetString(const char *VarName) const;

			void         Reset();
			void				 SetInputFileName(const char *);	
			void         Interprete(FILE *input) ;
			void         Interprete(const char *input) ;

			//         der letzte Fehler, Fehlernummer spezifizieren.
			Calculator::Error GetAndClearErrorState();
			const char *GetErrorString(Calculator::Error ErrNum) const;
			void         AbortOnError(int Line);

		protected:
			int         StartParser (FILE *input) ;
			int         StartParser (const char *input) ;
			Error     ErrorState;
			static const char *FirstPrgLine;
			static const char *LastPrgLine;
			static const char *ExpressionFileName;
			static const char *ExpressionVarName;
			static const char *ErrorStrings[WRONG_ERR_NUMBER+1];

		 #ifndef __OLD_INTERPRETE__

			 private:
				 StrClass OldFileName;
				 const char *LastBufferPtr;

		 #endif

  };

#endif
