%{
/*************************************************************************/
/*
 *  Datei           : calc.lex
 *  Inhalt          : Lexikon des Calculators
 *                    Dieses Lexikon ist fuer MKS-LEX bestimmt,
 *                    uns zwar fuer den -LC Mode (C++).
 *                    und mit der Skelett-Datei "calcscan.mks"
 *  Programmierer   : Sven Goethel
 *                                        Stapenhorststr.35a
 *                                        33615 Bielefeld
 *                                        0521/139228
 *  Erstellungsdatum: 6.7.1994
 *  nderungsdatum  : 14.12.1994
 *  Projekt         : fxmcnv
 *  Verzeichnis     :
 *  Dokumentation   : fxmcnv.doc
 *
 *
 * $Log: calc.lex  $
 * Revision 2.26  1995/06/06 08:48:21  Sven_Goethel_DFP
 * ok
 * Revision 2.25  1995/06/06 08:20:19  Sven_Goethel_DFP
 * lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
 * Revision 2.24  1995/04/07 11:35:01  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:34  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:05  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:04  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:41:38  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:08:07  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.4  1995/01/30 08:18:20  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.3  1995/01/27 17:45:26  Sven_Goethel
 * break - 
 * Revision 1.2  1994/12/16 16:54:01  Sven_Goethel
 * *** empty log message ***
 * Revision 1.1  1994/12/16 16:52:02  Sven_Goethel
 * Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# include "calc_y.h"

// PassNo=0 : Im ersten Pass die Lokation der FxmObjekte Orten ...
// PassNo=1 : Im zweiten Pass wirklich Parsen ...
//
// Fuer eine jede Datei muss eine Instanz des Parsers erzeugt werden.
// D.h. das der Parser mittels des Konstruktors alle noetigen
// Initialisierungen ausfuehrt, z.B.
// first_time:=1 und PassNo:=0 !!!!!

%}

%p 2300
%a 2000
%o 2000
%e 520
%n 220

%s S_NORMAL S_CMNT S_CMNT_2 S_SCAN_CALC_OBJ_LOCATION S_SCAN_CALC_OBJ_LOCATION_BEZ S_SCAN_CALC_OBJ_LOCATION_CMNT S_SCAN_CALC_OBJ_LOCATION_CMNT_2

%%

%{
  if(first_time) {
    BEGIN S_NORMAL;
    first_time=0;
  }
%}

<S_NORMAL>" "                   { ; }
<S_NORMAL>\t                    { ; }
<S_NORMAL>\n|\r                 { ; }

<S_NORMAL>CalculatorEnd       { return T_CALC_END; }
<S_NORMAL>Calculator          {
                              if(++PassNo%2) {
                                BEGIN S_SCAN_CALC_OBJ_LOCATION;
                              }
                              return T_CALC_START;
                            }
<S_NORMAL>FunctionEnd           { return (T_FUNC_DEF_END); }
<S_NORMAL>Function                      { return (T_FUNC_DEF); }


<S_NORMAL>while                         { yylval.UnionType.FilePos.ByteNo=yyftell()-yyleng-1; yylval.UnionType.FilePos.LineNo=yylineno; return T_WHILE; }
<S_NORMAL>if                            { return T_IF; }
<S_NORMAL>else                          { return T_ELSE; }
<S_NORMAL>return                        { return T_RETURN; }
<S_NORMAL>do                            { yylval.UnionType.FilePos.ByteNo=yyftell()-yyleng-1; yylval.UnionType.FilePos.LineNo=yylineno; return T_DO; }

<S_NORMAL>int                           { yylval.UnionType.varType=INT; return T_VARTYP_INT; }
<S_NORMAL>real                          { yylval.UnionType.varType=REELL; return T_VARTYP_REELL; }
<S_NORMAL>char                          { yylval.UnionType.varType=CHAR; return T_VARTYP_CHAR; }
<S_NORMAL>string                        { yylval.UnionType.varType=STRING; return T_VARTYP_STRING; }
<S_NORMAL>global                        { return T_GLOBAL; }

<S_NORMAL>printf                        { return T_PRINTF; }
<S_NORMAL>exit                           { return T_EXIT; }

<S_NORMAL>"=="                          { return(T_GLEICH); }
<S_NORMAL>"!="                          { return(T_UNGLEICH); }
<S_NORMAL>">"                           { return(T_GROESSER); }
<S_NORMAL>">="                          { return(T_GROESSERGLEICH); }
<S_NORMAL>"<"                           { return(T_KLEINER); }
<S_NORMAL>"<="                          { return(T_KLEINERGLEICH); }
<S_NORMAL>"&&"                          { return(T_UND); }
<S_NORMAL>"||"                          { return(T_ODER); }

<S_NORMAL>"sin"                         { return(T_SIN); }
<S_NORMAL>"cos"                         { return(T_COS); }
<S_NORMAL>"tan"                         { return(T_TAN); }
<S_NORMAL>"arcsin"                      { return(T_ARCSIN); }
<S_NORMAL>"arccos"                      { return(T_ARCCOS); }
<S_NORMAL>"arctan"                      { return(T_ARCTAN); }
<S_NORMAL>"pow"                         { return(T_POW); }
<S_NORMAL>"sqrt"                        { return(T_SQRT); }
<S_NORMAL>"ln"                          { return(T_LOG); }
<S_NORMAL>"log"                         { return(T_LOG10); }
<S_NORMAL>"exp"                         { return(T_EXP); }
<S_NORMAL>"neg"                         { return(T_NEG); }
<S_NORMAL>"abs"                         { return(T_ABS); }

<S_NORMAL>"M_PI"                        {
                                          yylval.VarVal.Set(REELL, 0, M_PI, NULL);
                                          return(T_ZAHL);
                                        }


<S_NORMAL>\"   {  Buffer[0]=0 ;
                  int c;
                  int i=0;

                  while ( ( c=yymapch('"', '\\') ) != EOF )
                  {
                    if ( BufferSize>i+2 )
                    {
                      Buffer[i++]=(char)c;
                      Buffer[i]=0;
                    } else {
                      yyerror("<CALC> String ist zu lang : %s\n", Buffer);
                      return T_ERROR;
                    }
                  }
                  yylval.VarVal.Set(STRING, 0, 0, Buffer);
                  return T_STRING;
               }

<S_NORMAL>\'   {  int c, c_c;
                  int i=0;

                  while ( ( c=yymapch('\'', '\\') ) != EOF )
                  {
                    if(i==0) c_c=c; // Das erste Zeichen Uebergeben !!!
                    i++;
                  }
                  if(i!=1) {
                    yyerror("<CALC> Einzelnes Zeichen nicht korrekt. \n", Buffer);
                    return T_ERROR;
                  }
                  yylval.VarVal.Set(CHAR, 0, c_c, NULL);
                  return T_ANYCHAR;
               }

<S_NORMAL>"/*"                  { BEGIN S_CMNT; }
<S_CMNT>.|\n|\r                 { ; }
<S_CMNT>"*/"                    { BEGIN S_NORMAL; }

<S_NORMAL>"//"                    { BEGIN S_CMNT_2; }
<S_CMNT_2>\n|\r                    { BEGIN S_NORMAL; }
<S_CMNT_2>.                        { ; }

<S_NORMAL>([a-zA-Z]|"_")+([a-zA-Z]|[0-9]|"_")*  {
                  yylval.VarVal.Set(STRING, 0, 0, yytext);
                  return  T_BEZEICHNER;
                }

<S_NORMAL>[0-9]+("."[0-9]+)?([eE][-+]?[0-9]+)? {
                     yylval.VarVal.Set(REELL, 0, atof(yytext), NULL);
                     return(T_ZAHL);
                }

<S_NORMAL>")"   {
                    yylval.UnionType.FilePos.ByteNo=yyftell();
                    yylval.UnionType.FilePos.LineNo=yylineno;
                    return (yytext[0]);
                }

<S_NORMAL>.             {  return (yytext[0]);  }


<S_SCAN_CALC_OBJ_LOCATION>^" "*CalculatorEnd {
                                          BEGIN S_NORMAL;
                                          yylval.UnionType.FilePos.ByteNo=yyftell()-yyleng-1;
                                          yylval.UnionType.FilePos.LineNo=yylineno;
                                          return T_CALC_END;
                                        }
<S_SCAN_CALC_OBJ_LOCATION>^" "*FunctionEnd       {
                                          return (T_FUNC_DEF_END);
                                        }
<S_SCAN_CALC_OBJ_LOCATION>^" "*Function     {
                                          yylval.UnionType.FilePos.ByteNo=yyftell()-yyleng-1;
                                          yylval.UnionType.FilePos.LineNo=yylineno;
                                          BEGIN S_SCAN_CALC_OBJ_LOCATION_BEZ;
                                          return (T_FUNC_DEF);
                                        }
<S_SCAN_CALC_OBJ_LOCATION_BEZ>([a-zA-Z]|"_")+([a-zA-Z]|[0-9]|"_")* {
                                          yylval.VarVal.Set(STRING, 0, 0, yytext);
                                          BEGIN S_SCAN_CALC_OBJ_LOCATION;
                                          return  T_BEZEICHNER;
                                        }

<S_SCAN_CALC_OBJ_LOCATION>"/*"           { BEGIN S_SCAN_CALC_OBJ_LOCATION_CMNT; }
<S_SCAN_CALC_OBJ_LOCATION_CMNT>.|\n|\r   { ; }
<S_SCAN_CALC_OBJ_LOCATION_CMNT>"*/"      { BEGIN S_SCAN_CALC_OBJ_LOCATION; }

<S_SCAN_CALC_OBJ_LOCATION>"//"             { BEGIN S_SCAN_CALC_OBJ_LOCATION_CMNT_2; }
<S_SCAN_CALC_OBJ_LOCATION_CMNT_2>\n|\r     { BEGIN S_SCAN_CALC_OBJ_LOCATION; }
<S_SCAN_CALC_OBJ_LOCATION_CMNT_2>.            { ; }


<S_SCAN_CALC_OBJ_LOCATION_BEZ>(" "|\n|\r|\t) { }
<S_SCAN_CALC_OBJ_LOCATION>.|\n|\r            { }

%%
