%{
/*************************************************************************/
/*
 *  Datei           : calc.y
 *  Inhalt          : Grammatik des Calculators
 *                      Diese Grammmatik ist fuer MKS-YACC bestimmt,
 *                      uns zwar fuer den -LC Mode (C++).
 *                      und mit der Skelett-Datei "calcpars.mks"
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 06.07.1994
 *  nderungsdatum  : 14.12.1994
 *  Projekt         : calc
 *  Verzeichnis     :
 *  Dokumentation   : calc.doc
 *
 *
 * $Log: calc.y  $
 * Revision 2.26  1995/06/06 08:48:23  Sven_Goethel_DFP
 * ok
 * Revision 2.25  1995/06/06 08:20:21  Sven_Goethel_DFP
 * lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
 * Revision 2.24  1995/04/07 11:35:04  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:35  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:10  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:09  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:41:40  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:08:15  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.3  1995/01/30 08:18:25  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.2  1995/01/27 17:45:31  Sven_Goethel
 * break - 
 * Revision 1.1  1994/12/16 16:52:04  Sven_Goethel
 * Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# include "calc_y.h"

/* Vereinfachung fuer die Synthese des Parsers.
   D.h. yacc von mks erzeugt YY_Types (enum) der Token Types,
   welche fuer den YYDEBUG Modus Verwendung finden.
   Diese YY_Types-Namen duerfen aber keinen Struktur-Dereferenzierer
   enthalten, also keinen Punkt <StrukturName>.<StrukturElement> !!!
*/
#define _FILEPOS_     UnionType.FilePos
#define _VARTYPE_     UnionType.varType
#define _VARVAL_      VarVal
#define _DVAL_        UnionType.dval

#ifndef __OLD_INTERPRETE__
  #define _P_ANWEISUNGEN_       ObjUnionType.pAnweisungen
  #define _P_ANWEISUNG_         ObjUnionType.pAnweisung
  #define _P_AUSDRUCK_           ObjUnionType.pAusdruck
  #define _P_PRODUKT_           ObjUnionType.pProdukt
  #define _P_OPERAND_           ObjUnionType.pOperand
  #define _P_ZUW_REF_LIST_       ObjUnionType.pZuweisungRefListe
  #define _P_AUSDRUCK_REF_LIST_ ObjUnionType.pAusdruckRefListe
  #define _P_ZUWEISUNG_         ObjUnionType.pZuweisung
  #define _P_VARDEF_REF_LIST_   ObjUnionType.pVarDefRefListe
  #define _P_VAR_DEF_           ObjUnionType.pVarDef

  #define _TYPE_1_ _P_OPERAND_
  #define _TYPE_2_ _VARVAL_
  #define _TYPE_3_ _P_PRODUKT_
  #define _TYPE_4_ _P_ANWEISUNG_
  #define _TYPE_5_ _P_AUSDRUCK_
  #define _TYPE_6_ _P_ANWEISUNGEN_
  #define _TYPE_7_ _P_OPERAND_
  #define _TYPE_8_ _P_ZUW_REF_LIST_
  #define _TYPE_9_ _P_ZUWEISUNG_
  #define _TYPE_10_ _P_AUSDRUCK_REF_LIST_
  #define _TYPE_11_ _P_VARDEF_REF_LIST_
  #define _TYPE_12_ _P_VAR_DEF_
#else
  #define _TYPE_1_ _VARVAL_
  #define _TYPE_2_ _VARVAL_
  #define _TYPE_3_ _VARVAL_
  #define _TYPE_4_ _VARVAL_
  #define _TYPE_5_ _VARVAL_
  #define _TYPE_6_ _VARVAL_
  #define _TYPE_7_ _VARVAL_
  #define _TYPE_8_ _DVAL_
  #define _TYPE_9_ _DVAL_
  #define _TYPE_10_ _DVAL_
  #define _TYPE_11_ _DVAL_
  #define _TYPE_12_ _DVAL_
#endif

// YYSTYPE declared in fxmcnv_y.h !!!!!
// ==> typedef TokenType YYSTYPE;

YYSTYPE yylval;  /* yy_scan sets this ..... allready extern declared */

%}

%token  <_FILEPOS_>     T_WHILE T_DO T_CALC_END T_FUNC_DEF ')'
%token  <_VARVAL_>      T_ZAHL T_STRING T_BEZEICHNER T_ANYCHAR
%token  <_VARTYPE_>     T_VARTYP_INT T_VARTYP_REELL
                        T_VARTYP_CHAR T_VARTYP_STRING

%token  T_IF T_ELSE
        T_PRINTF
        T_FUNC_DEF_END
        T_CALC_START T_EXIT
        T_ERROR T_RETURN T_GLOBAL

%left   '='
%left   T_ODER
%left   T_UND
%left   T_GLEICH T_UNGLEICH
%left   T_GROESSER T_GROESSERGLEICH T_KLEINER T_KLEINERGLEICH
%left   '+' '-'
%left   '*' '/'
%left   T_SIN T_COS T_TAN T_ARCSIN T_ARCCOS T_ARCTAN
%left   T_POW '^' T_LOG T_LOG10 T_EXP
%left   T_SQRT
%left   T_NEG '!' T_ABS

%type   <_TYPE_1_>     operand 
%type   <_TYPE_2_>     reelle_zahl 
%type   <_TYPE_3_>     produkt 
%type   <_TYPE_5_>     ausdruck boolean vergleich zuweisung ausdruck_opt 
                       summand 
%type   <_TYPE_7_>     func_call lokale_var

%type    <_TYPE_4_>     ausgabe else_opt anweisung anweisung2 
                       verzweigung schleifen variablen_def 
                       ausgabe exit anweisungs_block    
                       while do_while return 
%type   <_TYPE_5_>     argument 
%type   <_TYPE_6_>     anweisungen_opt anweisungen
%type   <_TYPE_7_>     func_calling
%type    <_TYPE_8_>     var_def_list 
%type    <_TYPE_9_>     var_def_list_elem
%type    <_TYPE_10_>     print_arg_liste_opt arg_liste_opt arg_liste 
%type    <_TYPE_11_>     func_arg_liste_opt func_arg_liste 
%type    <_TYPE_12_>     func_var_def
%type   <_VARTYPE_>    var_typ 
%type    <_VARTYPE_>     func_return_type_opt 
%type    <_VARTYPE_>     func_return_type


%%

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 0                                                         */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

inhalt          : erster_pass
                  {
                    #ifdef __OLD_INTERPRETE__
                      // Die Liste der Reihenfolge fuer die angelegten Variablen
                      // loeschen !!!
                      Vars.ClearVarDefOrder();
                      StopOk=0;
                    #endif
                  }
                  zweiter_pass
                  {
                    #ifdef __OLD_INTERPRETE__
                      // LOKALE VARIABLEN AUFRAEUMEN !!!!!!!!!!!!!
                      if(global_save.laenge()>0)
                      {
                        fprintf(stderr, "<CALC> WARNING ! global_save wurden nicht alle geloescht !\n");
                        fprintf(stderr, "<CALC> Loesche verbliebene global_save !\n");
                        while(global_save.laenge()>0) global_save.loesche(0);
                      }
                      if(SprungMarken.laenge()>0)
                      {
                        fprintf(stderr, "<CALC> WARNING ! Schleifen-Sprungmarkierungen wurden nicht alle geloescht !\n");
                        fprintf(stderr, "<CALC> Loesche verbliebene Schleifen-Sprungmarkierungen !\n");
                        while(SprungMarken.laenge()>0) SprungMarken.loesche(0);
                      }
                      if(ReturnListe.laenge()>0)
                      {
                        fprintf(stderr, "<CALC> WARNING ! Funktions-ReturnWerte wurden nicht alle entgegengenommen !\n");
                        fprintf(stderr, "<CALC> Loesche verbliebene ReturnWerte !\n");
                        while(ReturnListe.laenge()>0) ReturnListe.loesche(0);
                      }
                      if(ReturnFlags.laenge()>0)
                      {
                        fprintf(stderr, "<CALC> WARNING ! Funktions-ReturnFlags wurden nicht alle entgegengenommen !\n");
                        fprintf(stderr, "<CALC> Loesche verbliebene ReturnFlags !\n");
                        while(ReturnFlags.laenge()>0) ReturnFlags.loesche(0);
                      }
                      if(ArgListe.laenge()>0)
                      {
                        fprintf(stderr, "<CALC> INTERN-WARNING ! ArgumentenListe wurde nicht geloescht !\n");
                        fprintf(stderr, "<CALC> Loesche ArgumentenListe !\n");
                        while(ArgListe.laenge()>0) ArgListe.loesche(0);
                      }
                      if(BooleanStack.laenge()>0)
                      {
                        fprintf(stderr, "<CALC> INTERN-WARNING ! BooleanStack wurde nicht geloescht !\n");
                        fprintf(stderr, "<CALC> Loesche BooleanStack !\n");
                        while(BooleanStack.laenge()>0) BooleanStack.loesche(0);
                      }
                      // Label loeschen !!!!!
                      while(LabelLoc.laenge()>0) LabelLoc.loesche(0);
                      // Die Liste der Reihenfolge fuer die angelegten Variablen
                      // loeschen !!!
                      Vars.ClearVarDefOrder();
                    #else
                    #endif
                  }
                ;

erster_pass     : T_CALC_START
                  {
                    #ifndef __OLD_INTERPRETE__
                      ObjInhalt.Del();
                    #endif
                  }
                  func_locations_opt
                  T_CALC_END
                  {
                    // 2.Pass vom File-Anfang starten !
                    if(scan->yyfseek(0,SEEK_SET)!=0)
                    {
                      scan->yyerror("<CALC> Input File-Error, 2nd Pass, in front of : %s", scan->yytext);
                      YYABORT;
                    }
                    // die lexikalische Analyse registriert mittels
                    // der lokalen Variable PassNo den Pass-Wechsel.
                    // Somit werden im 1. Pass und im 2. Pass
                    // die entsprechenden / unterschiedlichen
                    // TOKEN zurueckgeliefert.
                    // PassNo Iteriert immer zwischen diesen beiden
                    // Modi.
                    scan->yy_reset();
                    yyclearin(); // lookahead token loeschen.
                    # if YYDEBUG
                      printf("<CALC> 1.Pass abgeschlossen\n");
                    # endif
                  }
                ;

zweiter_pass    : T_CALC_START '(' T_BEZEICHNER ')' ';'
                  {
                    #ifdef __OLD_INTERPRETE__
                      /* INITIALISIERUNGEN !!! */
                      FalseCase=0;
                      TrueCase=0;
                      Level=0;
                    #endif
                  }
                  anweisungen_opt
                  {
                    #ifdef __OLD_INTERPRETE__
                      if(Level!=0)
                      {
                        fprintf(stderr, "<CALC> INTERN-WARNING ! Level nach Programmende != 0\n");
                        fprintf(stderr, "<CALC> ( Level = %d ) \n", Level);
                      }
                      StopOk=1;
                    #else
                      ObjInhalt.pAnweisungen=$7;
                    #endif
                  }
                  func_def_list_opt
                  T_CALC_END ';'
                 ;

func_def_list_opt    
                :  
                | func_def_list
                ;

func_def_list    : func_def
                | func_def_list func_def
                ;

func_locations_opt
                :
                | func_locations
                ;

func_locations  : func_location
                | func_locations func_location
                ;

func_location    : T_FUNC_DEF T_BEZEICHNER T_FUNC_DEF_END
                  {
                    #ifdef __OLD_INTERPRETE__
                      if(LabelLoc.SetFilePos($2.strInhalt, $1)<1)
                      {
                        scan->yyerror("<CALC> LabelScan error A, in front of : %s", scan->yytext);
                        YYABORT;
                      }
                    #else
                      if(ObjInhalt.funktionen.FunktionenOff)
                        INT_ERR(__LINE__);
                      ObjInhalt.funktionen.Bezeichner.fuegeEin($2.strInhalt,
                        ObjInhalt.funktionen.Bezeichner.laenge()
                      );
                    #endif
                  }
                ;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 1                                                         */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

anweisungen_opt     :
                    { 
                      #ifndef __OLD_INTERPRETE__
                        $$=new Anweisungen();
                        if(!$$) INT_ERR(__LINE__);
                      #endif
                    }
                    | anweisungen 
                    { 
                      #ifndef __OLD_INTERPRETE__
                        $$=$1; 
                      #endif
                    }
                    ;

anweisungen         : anweisung
                    { 
                      #ifndef __OLD_INTERPRETE__
                        $$=new Anweisungen;
                        if(!$$) INT_ERR(__LINE__);
                        $$->fuegeEin($1, $$->laenge());
                      #endif
                    }
                    | anweisungen anweisung
                    { 
                      #ifndef __OLD_INTERPRETE__
                        $1->fuegeEin($2, $1->laenge());
                        $$=$1;
                      #endif
                    }
                    ;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 2                                                 */
/*                    Ab hier muss der FalseCase == 0 && TrueCase == 0        */
/*                    sein, so dass Anweisungen, etc. ausgefuehrt werden      */
/*                    koennen                                                 */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

anweisung       : anweisung2
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | verzweigung
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | schleifen
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                ;

anweisung2      : ausdruck_opt ';'
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=new AusdruckOpt(*$1);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | variablen_def ';'
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | ausgabe ';'
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | exit ';'
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | anweisungs_block
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | return
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                ;

exit            : T_EXIT '(' ausdruck ')'
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        if($3.Type==STRING)
                        {
                          scan->yyerror("<CALC> Fehler Exit-Parameter muss eine Zahl sein !\n in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        if((int)($3.rInhalt)==0) YYACCEPT;
                        else YYABORT;
                      }
                    #else
                      $$=new Exit(*$3);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

anweisungs_block
                : '{'
                  {
                    #ifdef __OLD_INTERPRETE__
                      // Eine Verschachtelungstiefe weiter.
                      Level++;
                      #if YYDEBUG
                        printf("<CALC> LEVEL : %d\n", Level);
                      #endif
                    #endif
                  }
                  anweisungen
                 '}'
                 {
                   #ifdef __OLD_INTERPRETE__
                     if ( FalseCase == 0 && TrueCase == 0 )
                     {
                       // Nur bei der Ausfuehrung wurden Variablen angelegt !!!
                       #if YYDEBUG
                         int i=
                       #endif
                       Vars.Loesche(Level);
                     }
                     // Eine Verschachtelungstiefe zurueck.
                     Level--;

                     #if YYDEBUG
                       printf("<CALC> LEVEL : %d ; Vars. geloescht: %d\n",
                         Level, i );
                     #endif
                   #else
                     $$=new Block(*$3, Vars);
                     if(!$$) INT_ERR(__LINE__);
                     $$->SetErrorMsg(CreateErrMsg());
                   #endif
                  }
                ;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 3                                                         */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

variablen_def   : var_typ
                  {
                    #ifdef __OLD_INTERPRETE__
                      // Die Liste der Reihenfolge fuer die angelegten Variablen
                      // loeschen !!!
                      Vars.ClearVarDefOrder();
                    #endif
                  }
                  var_def_list
                  { 
                    #ifndef __OLD_INTERPRETE__
                      assert($3!=NULL);
                      $$=new VariablenDef($1, *$3, Vars); 
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_GLOBAL var_typ
                  {
                    #ifdef __OLD_INTERPRETE__
                      global=1;
                      // Die Liste der Reihenfolge fuer die angelegten Variablen
                      // loeschen !!!
                      Vars.ClearVarDefOrder();
                    #endif
                  }
                  var_def_list 
                  {
                     #ifdef __OLD_INTERPRETE__
                        global=0; 
                     #else
                       assert($4!=NULL);
                       $$=new VariablenDef ( $2, *$4, Vars, 
                                              VariablenDef::T_FORCE_GLOBAL ); 
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                ;

var_def_list    : var_def_list_elem
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=new DeepRefListe<Zuweisung>();
                      if(!$$) INT_ERR(__LINE__);
                      $$->fuegeEin($1);
                    #endif
                  }
                | var_def_list ',' var_def_list_elem
                  {
                    #ifndef __OLD_INTERPRETE__
                      $1->fuegeEin($3, $1->laenge());
                      $$=$1;
                    #endif
                  }
                ;

var_def_list_elem
                : T_BEZEICHNER
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        VariablenInhalt vi(global==1?0:Level, VarDefType);
                        if ( !Vars.DefiniereVar($1.strInhalt.GetStrPtr(), vi) )
                        {
                          scan->yyerror("<CALC> VAR Definition-Fehler (Doppelte Def.), in front of : %s", scan->yytext);
                          YYABORT;
                        }
                      }
                    #else
                      VariablenInhalt vi(0, VarDefType, 0, NULL);
                      ConstOperand * pCO = new ConstOperand (vi);
                      if(!pCO) INT_ERR(__LINE__);
                      pCO->SetErrorMsg(CreateErrMsg());
                      Produkt * pP = new Produkt (*pCO);
                      if(!pP) INT_ERR(__LINE__);
                      pP->SetErrorMsg(CreateErrMsg());
                      Summand * pS = new Summand ( *pP );
                      if(!pS) INT_ERR(__LINE__);
                      pS->SetErrorMsg(CreateErrMsg());
                      $$ = new Zuweisung ( $1.strInhalt, *pS, Vars ); 
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_BEZEICHNER '=' global_save ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) 
                      {
                        global=global_save[0];
                        global_save.loesche(0);

                        if( $4.Type==STRING && VarDefType!=STRING )
                        {
                          scan->yyerror("<CALC> VAR Definition-Fehler (Falsche TypenKonversion), in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        $4.Type=VarDefType;
                        $4.Level=(global==1)?0:Level;
                        if ( !Vars.DefiniereVar($1.strInhalt.GetStrPtr(), $4) )
                        {
                          scan->yyerror("<CALC> VAR Definition-Fehler (Doppelte Def.), in front of : %s", scan->yytext);
                          YYABORT;
                        }
                      }
                    #else
                      $$ = new Zuweisung ( $1.strInhalt, *$4, Vars ); 
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

global_save     : {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) 
                      {
                        global_save.fuegeEin(global); 
                        global=0;
                      }
                    #endif
                   }
                ;

var_typ         : T_VARTYP_INT     { $$=VarDefType=$1; }
                | T_VARTYP_REELL   { $$=VarDefType=$1; }       
                | T_VARTYP_CHAR   { $$=VarDefType=$1; }
                | T_VARTYP_STRING  { $$=VarDefType=$1; }
                ;

ausgabe         : T_PRINTF '(' T_STRING print_arg_liste_opt ')'
                  {
                    #ifdef __OLD_INTERPRETE__

                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        Print(stdout,$3.strInhalt.GetStrPtr(), ArgListe);
                        while(ArgListe.laenge()>0) ArgListe.loesche(0);
                      }
                    #else
                      $$=new Ausgabe($3.strInhalt, *$4);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

print_arg_liste_opt
                : {
                    #ifndef __OLD_INTERPRETE__
                      $$=new DeepRefListe<Ausdruck>();
                      if(!$$) INT_ERR(__LINE__);
                    #endif
                  } 
                | ',' arg_liste
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=$2;
                    #endif
                  }
                ;

arg_liste_opt   : {
                    #ifndef __OLD_INTERPRETE__
                      $$=new DeepRefListe<Ausdruck>();
                      if(!$$) INT_ERR(__LINE__);
                    #endif
                  } 
                | arg_liste
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                ;

arg_liste       : argument
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=new DeepRefListe<Ausdruck>();
                      if(!$$) INT_ERR(__LINE__);
                      $$->fuegeEin($1);
                    #endif
                  } 
                | arg_liste ',' argument
                  {
                    #ifndef __OLD_INTERPRETE__
                      $1->fuegeEin($3, $1->laenge());
                      $$=$1;
                    #endif
                  } 
                ;

argument        : ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        ArgListe.fuegeEin($1);
                        ArgListe[0].Level=Level;
                      }
                    #else
                      $$=$1;
                    #endif
                  }
                ;

verzweigung     : T_IF '(' ausdruck ')'
                  {
                    #ifdef __OLD_INTERPRETE__
                      #if YYDEBUG
                        printf("<CALC> FalseCase : %d ; TrueCase : %d !\n",
                          FalseCase, TrueCase);
                      #endif
                      /* WENN BEDINGUNG CA. NULL ( wg. REELL ), */
                      /* SO HANDELT ES SICH UM DEN FALSE ZWEIG  */
                      VariablenInhalt vi(Level, $3.Type); // NULL-Wertig...
                      if ( $3==vi )
                      {
                         #if YYDEBUG
                           printf("<CALC> ausdruck = FALSE !\n");
                         #endif
                         FalseCase++;
                         BooleanStack.fuegeEin(0);
                      } else {
                         #if YYDEBUG
                           printf("<CALC> ausdruck = TRUE !\n");
                           if ( FalseCase == 0 && TrueCase == 0 )
                             printf("<CALC> TRUE Zweig aktiv !\n");
                           else
                             printf("<CALC> TRUE Zweig passiv !\n");
                         #endif
                        BooleanStack.fuegeEin(1);
                      }
                    #endif
                  }
                  anweisung2
                   {
                    #ifdef __OLD_INTERPRETE__
                      if ( !BooleanStack[0] ) FalseCase--;
                      BooleanVal=BooleanStack[0];
                      BooleanStack.loesche(0);
                    #endif
                  }
                  else_opt
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=new Verzweigung ( *$3, *$6, *$8); 
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                   }
                ;

else_opt        : {
                    #ifndef __OLD_INTERPRETE__
                      $$=new AusdruckOpt();
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_ELSE
                  {
                    #ifdef __OLD_INTERPRETE__
                      BooleanStack.fuegeEin(BooleanVal);
                      /* WENN letzter Booleanwert TRUE, */
                      /* SO HANDELTE ES SICH UM DEN TRUE ZWEIG           */
                      if ( BooleanStack[0] ) {
                        #if YYDEBUG
                          printf("<CALC> FALSE Zweig Skipped !\n");
                        #endif
                        TrueCase++;
                      } else {
                        #if YYDEBUG
                          if ( FalseCase == 0 && TrueCase == 0 )
                            printf("<CALC> FALSE Zweig aktiv !\n");
                          else
                            printf("<CALC> FALSE Zweig passiv !\n");
                        #endif
                      }
                    #endif
                  }
                  anweisung
                  {
                    #ifdef __OLD_INTERPRETE__
                      /* TRUE ZAEHLER EVT. AUFHEBEN */
                      if ( BooleanStack[0] ) TrueCase--;
                      BooleanStack.loesche(0);
                    #else
                      $$=$3;
                    #endif
                  }
                ;

schleifen       : while 
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                | do_while
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=$1;
                    #endif
                  }
                ;

while           : T_WHILE '(' ausdruck ')'
                  {
                    #ifdef __OLD_INTERPRETE__
                      SprungMarken.fuegeEin($1);
                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        // WENN BEDINGUNG CA. NULL ( wg. REELL ),
                        // SO HANDELT ES SICH UM DEN FALSE ZWEIG
                        // D.H. DIE SCHLEIFE IST BEENDET !!!
                        VariablenInhalt vi(Level, $3.Type); // NULL-Wertig...
                        if ( $3==vi )
                        {
                          FalseCase++;
                          BooleanStack.fuegeEin(0);
                        } else BooleanStack.fuegeEin(1);
                      } else {
                        FalseCase++;
                        BooleanStack.fuegeEin(0);
                      }
                    #endif
                  }
                  anweisung
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase==0 )
                      {
                        /* und weiter geht's in der Schleife */
                        /* FilePos vor 'while' anfahren !!!! */
                        if ( scan->yyfseek( SprungMarken[0].ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
                        {
                          scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        scan->yy_reset();
                        scan->yylineno=SprungMarken[0].LineNo;
                        yyclearin(); // lookahead token loeschen.
                      }
                      SprungMarken.loesche(0);
                      if ( !BooleanStack[0] ) FalseCase--;
                      BooleanStack.loesche(0);
                    #else
                      $$=new Schleife ( *$3, *$6, Schleife::T_WHILE );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

do_while        : T_DO
                  {
                    #ifdef __OLD_INTERPRETE__
                      SprungMarken.fuegeEin($1);
                    #endif
                  }
                  anweisung
                  T_WHILE '(' ausdruck ')' ';'
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) 
                      {
                        VariablenInhalt vi(Level, $6.Type); // NULL-Wertig...
                        if ( $6!=vi )
                        {
                          /* und weiter geht's in der Schleife */
                          /* FilePos vor 'do' anfahren !!!!    */
                          if ( scan->yyfseek( SprungMarken[0].ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
                          {
                            scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
                            YYABORT;
                          }
                          scan->yy_reset();
                          scan->yylineno=SprungMarken[0].LineNo;
                          yyclearin(); // lookahead token loeschen.
                        }
                      }
                      SprungMarken.loesche(0);
                    #else
                      $$=new Schleife ( *$6, *$3, Schleife::T_DOWHILE );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

func_call       : func_calling
                  func_def
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$=ReturnListe[0];
                        ReturnListe.loesche(0);
                        ReturnFlags.loesche(0);
                      }
                    #else
                      INT_ERR(__LINE__);
                    #endif
                  }
                | func_calling
                  {
                    #ifdef __OLD_INTERPRETE__
                      // Ausfuehrung war untersagt, FalseCase TrueCase !!!
                      $$.Set();
                    #else
                      $$=$1;
                    #endif
                  }
                ;

func_calling    : T_BEZEICHNER '('
                  {
                    #ifdef __OLD_INTERPRETE__
                      // Level auf Levelnivau der Func-Def-Parameter anheben
                      Level++;
                    #endif
                  }
                  arg_liste_opt ')'
                  {
                    #ifdef __OLD_INTERPRETE__
                      // Level Normalisieren....
                      Level--;
                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        // Ruecksprung Merken !!!
                        SprungMarken.fuegeEin($5);
  
                        FilePosition fPos;
  
                        if ( !LabelLoc.GetFilePos($1.strInhalt, fPos) )
                        {
                          scan->yyerror("<CALC> Fehler waehrend des Uebergangs zur Funktionsdefinition,\n in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        /* und weiter gehts mit der Funktionsdefinition */
                        if ( scan->yyfseek( fPos.ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
                        {
                          scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        scan->yy_reset();
                        scan->yylineno=fPos.LineNo;
                        yyclearin(); // lookahead token loeschen.
                      } else {
                        // KEIN func_def !!!!
                      }
                      // Die Liste der Reihenfolge fuer die angelegten Variablen
                      // loeschen !!!
                      Vars.ClearVarDefOrder();
                    #else
                      int fidx=
                       ObjInhalt.funktionen.Bezeichner.istElement($1.strInhalt);
                      if(fidx<0)
                      { 
                        scan->yyerror("<CALC> Aufruf einer undefinierten Funktion namens %s\n",
                          (const char *)($1.strInhalt));
                        YYABORT;
                      }
                      $$=new FuncCall ( ObjInhalt.funktionen, fidx, *$4 );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

func_def        : T_FUNC_DEF T_BEZEICHNER
                  {
                    #ifdef __OLD_INTERPRETE__

                      if(StopOk) YYACCEPT;

                      // Sicher
                      if(FalseCase!=0 || TrueCase!=0)
                      {
                        scan->yyerror("<CALC> WARNING ! Unbefugter Bereich !\n");
                        YYABORT;
                      }
                      // Eine Verschachtelungstiefe weiter.
                      Level++;
                      #if YYDEBUG
                        printf("<CALC> LEVEL : %d\n", Level);
                      #endif
                    #endif
                  }
                  '(' func_arg_liste_opt ')' func_return_type_opt ';'
                  {
                    #ifdef __OLD_INTERPRETE__
                      if(FalseCase!=0 || TrueCase!=0)
                      {
                        scan->yyerror("<CALC> WARNING ! Unbefugter Bereich !\n");
                        YYABORT;
                      }
                      // Argumente uebernehmen !!!
                      if ( !Vars.SetzeWerte(Level, ArgListe) )
                      {
                        scan->yyerror("<CALC> Functions Parameter-Fehler, in front of : %s", scan->yytext);
                        YYABORT;
                      }
                      // loeschen !!!!
                      while(ArgListe.laenge()>0) ArgListe.loesche(0);
                      // return Variablen erzeugen !!!
                      // Level hier egal !!!
                      VariablenInhalt vi(0, $7, 0, NULL);
                      ReturnListe.fuegeEin(vi);
                      ReturnFlags.fuegeEin(1); /* RETURN erlauben */
                    #endif
                  }
                  anweisungen_opt 
                  T_FUNC_DEF_END ';'
                  {
                    #ifndef __OLD_INTERPRETE__
                      if(ObjInhalt.funktionen.FunktionenOff)
                        INT_ERR(__LINE__);
                      int idx = ObjInhalt.funktionen.Bezeichner.
                        istElement($2.strInhalt);
                      // be sure .....
                      assert ( idx >=0 );
                      assert ( idx== 
                               ObjInhalt.funktionen.InitVarDefRefListeRefListe.
                               laenge()
                              );
                      assert ( idx==
                               ObjInhalt.funktionen.AnweisungenRefListe.
                               laenge()
                              );
                      assert ( idx==
                               ObjInhalt.funktionen.ReturnValListe.
                               laenge()
                              );
                      ObjInhalt.funktionen.InitVarDefRefListeRefListe.
                        fuegeEin($5, idx);
                      ObjInhalt.funktionen.AnweisungenRefListe.
                        fuegeEin($10,idx);
                      VariablenInhalt vi (0, INT, 0, NULL);
                      ObjInhalt.funktionen.ReturnValListe.
                        fuegeEin(vi,idx);
                    #else
                      #if YYDEBUG
                        printf("<CALC> LEVEL : %d ; Vars. geloescht: %d\n",
                          Level-1, Vars.Loesche(Level) );
                      #else
                        Vars.Loesche(Level);
                      #endif
  
                      // Eine Verschachtelungstiefe zurueck.
                      Level--;
  
                      // RETURN entsorgen
                      if(ReturnFlags[0]==-1) {
                        // Anweisungen wieder erlauben
                        FalseCase--;
                        /* FunktionswertRueckgabe gefragt ???? */
                        if( ReturnListe[0].Type==NONE && ReturnVal.Type!=NONE )
                        {
                          scan->yyerror("<CALC> VAR Funktionswert-Rueckgabe nicht gefragt\n, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        // TypeCasting, ausser STRING -> Zahl ... (INT,REELL,...)
                        if( ( ReturnVal.Type==STRING && ReturnListe[0].Type!=STRING ) ||
                            ( ReturnListe[0].Type==STRING && ReturnVal.Type!=STRING )
                          )
                        {
                          scan->yyerror("<CALC> VAR Funktionswert-Typ-Fehler, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        // Zuweisung !!!
                        ReturnListe[0]=ReturnVal;
                      } else {
                        if(ReturnListe[0].Type!=NONE) {
                          scan->yyerror("<CALC> VAR Funktionswert-Rueckgabe-Fehlt, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                      }
  
                      if(FalseCase!=0 || TrueCase!=0)
                      {
                        scan->yyerror("<CALC> WARNING ! IF-THEN-ELSE Verschachtelungen wurden nicht aufgeloest !\n");
                        YYABORT;
                      }
                      /* und weiter geht's im "Hauptprogramm" */
                      /* hinter der Klammer-Zu  !!!!             */
                      if ( scan->yyfseek( SprungMarken[0].ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
                      {
                        scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
                        YYABORT;
                      }
                      scan->yy_reset();
                      scan->yylineno=SprungMarken[0].LineNo;
                      SprungMarken.loesche(0);
                      yyclearin(); // lookahead token loeschen.
                    #endif
                  }
                ;

func_arg_liste_opt
                : { 
                    #ifndef __OLD_INTERPRETE__
                      $$=new DeepRefListe<VariablenDef>();
                      if(!$$) INT_ERR(__LINE__);
                    #endif
                  }
                | func_arg_liste 
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=$1; 
                    #endif
                  }
                ;

func_arg_liste  : func_var_def
                  { 
                    #ifndef __OLD_INTERPRETE__
                      $$=new DeepRefListe<VariablenDef>();
                      if(!$$) INT_ERR(__LINE__);
                      $$->fuegeEin($1);
                    #endif
                  }
                | func_arg_liste ',' func_var_def
                  {
                    #ifndef __OLD_INTERPRETE__
                      $1->fuegeEin($3, $1->laenge());
                      $$=$1;
                    #endif
                  }
                ;

func_var_def    : var_typ var_def_list_elem
                  {
                    #ifndef __OLD_INTERPRETE__
                      DeepRefListe<Zuweisung> * pZl = 
                        new DeepRefListe<Zuweisung>();
                       if(!pZl) INT_ERR(__LINE__);
                      pZl->fuegeEin($2);
                      $$=new VariablenDef ($1, *pZl, Vars);
                       if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

func_return_type_opt
                : {
                   #ifdef __OLD_INTERPRETE__
                      $$=NONE; 
                   #else
                   #endif
                 }
                | func_return_type {
                    #ifdef __OLD_INTERPRETE__
                       $$=$1; 
                    #else
                    #endif
                  }
                ;

func_return_type
                : ':' var_typ 
                  {
                     #ifdef __OLD_INTERPRETE__
                        $$=$2; 
                     #else
                     #endif
                  }
                ;

return            : T_RETURN ausdruck_opt ';'
                  {
                    #ifndef __OLD_INTERPRETE__
                      $$=new Return(*$2, ObjInhalt.funktionen,
                                    ObjInhalt.funktionen.ReturnValListe
                                    .laenge());
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #else
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        if(ReturnFlags.laenge()>0) {
                          if(ReturnFlags[0]==1) {
                            ReturnVal=$2;
                            FalseCase++; /* Alles skippen */
                            ReturnFlags[0]=-1;
                          } else {
                            scan->yyerror("<CALC> 'return' (?) hier nicht erlaubt !!!, in front of : %s", scan->yytext);
                            YYABORT;
                          }
                        } else {
                          scan->yyerror("<CALC> 'return' (N) hier nicht erlaubt !!!, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                      }
                    #endif
                  }
                ;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 4                                                         */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

ausdruck_opt    : {
                     #ifdef __OLD_INTERPRETE__
                       $$.Set(); 
                     #else
                       $$=new Ausdruck();
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                  }
                | ausdruck  {
                     #ifdef __OLD_INTERPRETE__
                        $$=$1; 
                     #else
                       $$=$1;
                     #endif
                   }
                ;

ausdruck        : summand   { $$=$1; }
                | vergleich { $$=$1; }
                | zuweisung { $$=$1; }
                | boolean   { $$=$1; }
                ;

boolean            : ausdruck T_UND ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1&&$3, NULL);
                    #else
                      $$=new Boolean(*$1, *$3, Boolean::T_AND);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck T_ODER ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1||$3, NULL);
                    #else
                      $$=new Boolean(*$1, *$3, Boolean::T_OR);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

vergleich       : ausdruck T_GLEICH ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1==$3, NULL);
                    #else
                      $$=new Vergleich ( *$1, *$3, Vergleich::T_EQ);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck T_GROESSERGLEICH ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1>=$3, NULL);
                    #else
                      $$=new Vergleich ( *$1, *$3, Vergleich::T_GE);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck T_GROESSER ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1>$3, NULL);
                    #else
                      $$=new Vergleich ( *$1, *$3, Vergleich::T_GT);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck T_KLEINER ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1<$3, NULL);
                    #else
                      $$=new Vergleich ( *$1, *$3, Vergleich::T_LT);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck T_KLEINERGLEICH ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1<=$3, NULL);
                    #else
                      $$=new Vergleich ( *$1, *$3, Vergleich::T_LE);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck T_UNGLEICH ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$.Set(INT, Level, $1!=$3, NULL);
                    #else
                      $$=new Vergleich ( *$1, *$3, Vergleich::T_NE);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

zuweisung       : T_BEZEICHNER '=' ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 ) {
                        if ( !Vars.SetzeWert(Level, $1.strInhalt.GetStrPtr(), $3) )
                        {
                          scan->yyerror("<CALC> VAR Zugriff Fehler (Falsche TypenKonversion oder Falscher Gueltigkeitbereich),\n in front of : %s Variable : %s",
                          scan->yytext, $1.strInhalt.GetStrPtr());
                          YYABORT;
                        }
                      }
                      $$=$3;
                    #else
                      $$=new Zuweisung ( $1.strInhalt, *$3, Vars);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_BEZEICHNER '[' ausdruck ']' '=' ausdruck
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        VariablenInhalt vi;
                        if( !Vars.HoleWert(Level, $1.strInhalt.GetStrPtr(), vi) )
                        {
                          scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        // Nur fuer vi.Type==STRING !!!!!!
                        if(vi.Type==STRING)
                        {
                          if($3.Type!=STRING)
                          {
                            (vi.strInhalt.GetStrPtr())[(int)($3.rInhalt)]=(int)($6.rInhalt);
                            if ( !Vars.SetzeWert(Level, $1.strInhalt.GetStrPtr(), vi) )
                            {
                              scan->yyerror("<CALC> VAR Zugriff Fehler (Falsche TypenKonversion oder Falscher Gueltigkeitbereich),\n in front of : %s", scan->yytext);
                              YYABORT;
                            }
                          } else {
                              scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n in front of : %s", scan->yytext);
                              YYABORT;
                          }
                        } else {
                            scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Array-Dereferenzierer nur fuer STRINGS !),\n in front of : %s", scan->yytext);
                            YYABORT;
                        }
                      } else $$.Set();
                    #else
                      $$=new Zuweisung ( $1.strInhalt, *$3, *$6, Vars);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 4.2                                                       */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

summand         : produkt                  
                   {
                    #ifdef __OLD_INTERPRETE__
                       $$=$1; 
                    #else
                      $$=new Summand(*$1);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck '+' produkt
                  {
                    #ifdef __OLD_INTERPRETE__
                        if($1.Type==STRING&&$3.Type==STRING)
                        {
                          $$.Set(STRING, Level, 0, $1.strInhalt.GetStrPtr());
                          $$.strInhalt.StrCat($3.strInhalt);
                        } else $$.Set($1.GetBiggestType($3), Level, $1.rInhalt+$3.rInhalt, NULL);
                    #else
                      $$=new Summand(*$1, *$3, Summand::T_ADD);
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | ausdruck '-' produkt  {
                       #ifdef __OLD_INTERPRETE__
 $$.Set($1.GetBiggestType($3), Level, $1.rInhalt-$3.rInhalt, NULL); 
                        #else
                         $$=new Summand(*$1, *$3, Summand::T_SUB);
                         if(!$$) INT_ERR(__LINE__);
                         $$->SetErrorMsg(CreateErrMsg());
                       #endif
                     }
                ;

produkt         : operand                
                  {
                    #ifdef __OLD_INTERPRETE__
                      $$=$1; 
                    #else
                      $$=new Produkt ( *$1 );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | produkt '*' operand     
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$.Set($1.GetBiggestType($3), Level, 
                               $1.rInhalt*$3.rInhalt, NULL);
                      } else $$.Set();
                    #else
                      $$=new Produkt ( *$1, *$3, Produkt::T_MUL );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | produkt '/' operand     
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        if($3.rInhalt!=0) {
                          $$.Set($1.GetBiggestType($3), Level, 
                                $1.rInhalt/$3.rInhalt, NULL);
                        } else {
                          scan->yyerror("<CALC> DIVISION durch Null, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                      } else $$.Set();
                    #else
                      $$=new Produkt ( *$1, *$3, Produkt::T_DIV );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | produkt '^' operand     
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$.Set($1.GetBiggestType($3), Level, 
                                pow($1.rInhalt,$3.rInhalt), NULL);
                      } else $$.Set();
                    #else
                      $$=new Produkt ( *$1, *$3, Produkt::T_POW );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_POW '(' ausdruck ',' ausdruck ')'
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        if($3.Type==STRING||$5.Type==STRING)
                        {
                          scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        $$.Set($3.GetBiggestType($5), Level, 
                               pow($3.rInhalt,$5.rInhalt), NULL);
                      } else $$.Set();
                    #else
                      $$=new Produkt ( *$3, *$5, Produkt::T_POW );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

operand         : reelle_zahl  
                  {
                    #ifdef __OLD_INTERPRETE__
                       $$=$1; 
                    #else
                      $$=new ConstOperand ( $1 );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_STRING                
                  {
                    #ifdef __OLD_INTERPRETE__
                       $$=$1; 
                    #else
                      $$=new ConstOperand ( $1 );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | func_call   { $$=$1; }
                | lokale_var  { $$=$1; }
                | T_SIN operand         
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=sin($$.rInhalt);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_SIN );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_COS operand         
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=cos($$.rInhalt);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_COS );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_TAN operand         
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=tan($$.rInhalt);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_TAN );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_ARCSIN operand      
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$=$2;
                        $$.rInhalt=asin($$.rInhalt);
                      } else $$.Set();
                    #else
                      $$=new MathOperand ( *$2, MathOperand::T_ARCSIN );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_ARCCOS operand      
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$=$2;
                        $$.rInhalt=acos($$.rInhalt);
                      } else $$.Set();
                    #else
                      $$=new MathOperand ( *$2, MathOperand::T_ARCCOS );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_ARCTAN operand      
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$=$2;
                        $$.rInhalt=atan($$.rInhalt);
                      } else $$.Set();
                    #else
                      $$=new MathOperand ( *$2, MathOperand::T_ARCTAN );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_LOG operand         
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=log($$.rInhalt);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_LN );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_LOG10 operand       
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=log10($$.rInhalt);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_LOG );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_EXP operand         
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=exp($$.rInhalt);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_EXP );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_SQRT operand        
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$=$2;
                        $$.rInhalt=sqrt($$.rInhalt);
                      } else $$.Set();
                    #else
                      $$=new MathOperand ( *$2, MathOperand::T_SQRT );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_NEG  operand        
                  {
                     #ifdef __OLD_INTERPRETE__
                        if ( FalseCase == 0 && TrueCase == 0 )
                        {
                          $$=$2;
                          $$.rInhalt=$$.rInhalt*(-1);
                        } else $$.Set();
                     #else
                       $$=new MathOperand ( *$2, MathOperand::T_NEG );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                   }
                | T_ABS operand            
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        $$=$2;
                        $$.rInhalt=fabs($$.rInhalt);
                      } else $$.Set();
                    #else
                      $$=new MathOperand ( *$2, MathOperand::T_ABS );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | '(' ausdruck ')'      
                  {
                     #ifdef __OLD_INTERPRETE__
                       $$=$2; 
                     #else
                       $$=new AusdruckOperand ( *$2 );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                  }
                | T_ANYCHAR                
                  {
                     #ifdef __OLD_INTERPRETE__
                       $$=$1; 
                     #else
                       $$=new ConstOperand ( $1 );
                       if(!$$) INT_ERR(__LINE__);
                       $$->SetErrorMsg(CreateErrMsg());
                     #endif
                  }
                | '!' operand
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        VariablenInhalt vi(Level, $2.Type); // NULL Wertig !
                        $$.Set(INT, Level, $2==vi, NULL);
                      } else $$.Set();
                    #else
                      $$=new MathOperand ( *$2, MathOperand::T_NOT );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                  Level 5  ; REELL-WERTIGE VARIABLEN HOLEN !!!!                   */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

reelle_zahl     : T_ZAHL          { $$=$1; }
                | T_ZAHL ':' T_ZAHL
                  {
                    #ifdef __OLD_INTERPRETE__
                      /* UHRZEIT => STUNDE:MINUTE immer REELL */
                      $$.Set(REELL, Level, $1.rInhalt*3600+$3.rInhalt*60, NULL);
                    #else
                      /* UHRZEIT => STUNDE:MINUTE immer REELL */
                      $$.Set(REELL, 0, $1.rInhalt*3600+$3.rInhalt*60, NULL);
                    #endif
                  }
                | '+' T_ZAHL     { $$=$2; }
                | '-' T_ZAHL     { $$=$2; $$.rInhalt*=-1; }
                ;

lokale_var      : T_BEZEICHNER
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        if(!Vars.HoleWert(Level, $1.strInhalt.GetStrPtr(), $$))
                        {
                          scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler, in front of : %s, Variable %s",
                          scan->yytext, $1.strInhalt.GetStrPtr());
                          YYABORT;
                        }
                      } else $$.Set();
                    #else
                      $$=new VarOperand ( $1.strInhalt, Vars );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                | T_BEZEICHNER '[' ausdruck ']'
                  {
                    #ifdef __OLD_INTERPRETE__
                      if ( FalseCase == 0 && TrueCase == 0 )
                      {
                        VariablenInhalt vi;
                        if(!Vars.HoleWert(Level, $1.strInhalt.GetStrPtr(), vi))
                        {
                          scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler, in front of : %s", scan->yytext);
                          YYABORT;
                        }
                        // Nur fuer vi.Type==STRING !!!!!!
                        if(vi.Type==STRING)
                        {
                          if($3.Type!=STRING)
                          {
                            $$.Set(CHAR, Level, (double) ( (vi.strInhalt.GetStrPtr()) [(int)($3.rInhalt)] ) );
                          } else {
                              scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n in front of : %s", scan->yytext);
                              YYABORT;
                          }
                        } else {
                            scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Array-Dereferenzierer nur fuer STRINGS !),\n in front of : %s", scan->yytext);
                            YYABORT;
                        }
                      } else $$.Set();
                    #else
                      $$=new VarOperand ( $1.strInhalt, *$3, Vars );
                      if(!$$) INT_ERR(__LINE__);
                      $$->SetErrorMsg(CreateErrMsg());
                    #endif
                  }
                ;

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
%%

