/*************************************************************************/
/*
 *  Datei           : calc_y.cpp
 *  Inhalt          : Definition fuer Funktionen der Klassen :
 *                        o FilePosition
 *                        o VariablenInhalt
 *                        o Variablen
 *                        o CalcObjectDefLocus
 *                      Weitere Funktions-Definitionen :
 *                        o Print
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 06.07.1994
 *  nderungsdatum  : 14.12.1994
 *  Projekt         : calc
 *  Verzeichnis     :
 *  Dokumentation   : calc.doc
 *
 *
 * $Log: calc_y.cc  $
 * Revision 2.26  1995/06/06 08:48:24  Sven_Goethel_DFP
 * ok
 * Revision 2.25  1995/06/06 08:20:22  Sven_Goethel_DFP
 * lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
 * Revision 2.24  1995/04/07 11:35:06  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:37  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:15  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:14  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:41:35  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:07:57  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.3  1995/01/30 08:18:12  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.2  1995/01/27 17:45:18  Sven_Goethel
 * break - 
 * Revision 1.1  1994/12/16 16:52:06  Sven_Goethel
 * Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# include "calc_y.h"

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Vergleichsoperator der Klasse FilePosition
    ----------------------------------------
    int ::operator==(const FilePosition &m) const

    - Beschreibung
    --------------
    Vergleich zwischen zwei Elementen der Klasse FilePosition

    - Parameter
    -----------
    E: m     Element der Klasse FilePosition

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - ungleich
    1 - gleich

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int FilePosition::operator==(const FilePosition &m) const
{
  if(ByteNo==m.ByteNo && LineNo==m.LineNo) return 1;
  else return 0;
}

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Zuweisungsoperator der Klasse VariablenInhalt
    ------------------------------------------
    VariablenInhalt& ::operator=(const VariablenInhalt &m)

    - Beschreibung
    --------------
    Zuweisung einer Instanz zur *this Instanz

    - Parameter
    -----------
    E:m        Instanz der Klasse VariablenInhalt

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    Referenz auf die zugewiesene *this Instanz

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
VariablenInhalt &VariablenInhalt::operator=(const VariablenInhalt &m)
{
  if(this!=&m) {
    Level=m.Level;
    Type=m.Type;
    rInhalt=m.rInhalt;
    strInhalt=m.strInhalt;
  }
  return *this;
}

/*DOCST------------------------------------------------------------------------------

    Boolesche-Operatoren der Klasse VariablenInhalt
    ------------------------------------------
    int ::operator==(const VariablenInhalt&) const
    int ::operator>=(const VariablenInhalt&) const
    int ::operator<=(const VariablenInhalt&) const
    int ::operator>(const VariablenInhalt&) const
    int ::operator<(const VariablenInhalt&) const
    int ::operator!=(const VariablenInhalt&) const
    int ::operator&&(const VariablenInhalt&) const
    int ::operator||(const VariablenInhalt&) const

    - Beschreibung
    --------------
    Vergleich zwischen zwei Elementen der Klasse VariablenInhalt

    - Parameter
    -----------
    E:m        Element der Klasse VariablenInhalt

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - ungleich
    1 - gleich

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int VariablenInhalt::operator==(const VariablenInhalt &m) const
{
  if( ( Type==STRING && m.Type!=STRING ) ||
      ( m.Type==STRING && Type!=STRING )
    ) return 0;
  if(Type==STRING ) {
    return (strInhalt==m.strInhalt) ;
  } else {
    if( fabs(rInhalt-m.rInhalt)<=MASCHINE::toleranz)
      return 1;
  }
  return 0;
}

int VariablenInhalt::operator>=(const VariablenInhalt &m) const
{
  if( Type==STRING && m.Type!=STRING ) return 1;
  if( m.Type==STRING && Type!=STRING ) return 0;
  if(Type==STRING) {
    return (strInhalt>=m.strInhalt);
  } else {
    if( rInhalt >= m.rInhalt )
      return 1;
  }
  return 0;
}

int VariablenInhalt::operator<=(const VariablenInhalt &m) const
{
  if( Type==STRING && m.Type!=STRING ) return 0;
  if( m.Type==STRING && Type!=STRING ) return 1;
  if(Type==STRING) {
    return (strInhalt<=m.strInhalt);
  } else {
    if( rInhalt <= m.rInhalt )
      return 1;
  }
  return 0;
}

int VariablenInhalt::operator>(const VariablenInhalt &m) const
{
  if( Type==STRING && m.Type!=STRING ) return 1;
  if( m.Type==STRING && Type!=STRING ) return 0;
  if(Type==STRING) {
    return (strInhalt>m.strInhalt);
  } else {
    if( rInhalt > m.rInhalt )
      return 1;
  }
  return 0;
}

int VariablenInhalt::operator<(const VariablenInhalt &m) const
{
  if( Type==STRING && m.Type!=STRING ) return 0;
  if( m.Type==STRING && Type!=STRING ) return 1;
  if(Type==STRING) {
    return (strInhalt<m.strInhalt);
  } else {
    if( rInhalt < m.rInhalt )
      return 1;
  }
  return 0;
}

int VariablenInhalt::operator!=(const VariablenInhalt &m) const
{
  if( ( Type==STRING && m.Type!=STRING ) ||
      ( m.Type==STRING && Type!=STRING )
    ) return 1;
  if(Type==STRING) {
    return (strInhalt!=m.strInhalt) ;
  } else {
    if( fabs(rInhalt-m.rInhalt)>MASCHINE::toleranz)
      return 1;
  }
  return 0;
}

int VariablenInhalt::operator&&(const VariablenInhalt &m) const
{
  if( ( Type==STRING && m.Type!=STRING ) ||
      ( m.Type==STRING && Type!=STRING )
    ) return 0;
  if(Type==STRING) return 1;
  else return (fabs(rInhalt)>MASCHINE::toleranz
    &&fabs(m.rInhalt)>MASCHINE::toleranz);
}

int VariablenInhalt::operator||(const VariablenInhalt &m) const
{
  if( Type==STRING )
  {
    if(strInhalt.laenge()>0) return 1;
  }
  if( m.Type==STRING )
  {
    if(m.strInhalt.laenge()>0) return 1;
  }
  else return (fabs(rInhalt)>MASCHINE::toleranz
    ||fabs(m.rInhalt)>MASCHINE::toleranz);
  return 0;
}

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse VariablenInhalt
    ------------------------------------------
    VarType ::GetBiggestType(const VariablenInhalt &) const

    - Beschreibung
    --------------
    Gibt den groessten Variablentyp zurueck.

    - Parameter
    -----------
    E:m        Element der Klasse VariablenInhalt

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    VarTyp, groesster Variablentyp

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
VarType VariablenInhalt::GetBiggestType(const VariablenInhalt &m) const
{
  if(m.Type == STRING || Type==STRING ) return STRING;
  if(m.Type == REELL || Type==REELL ) return REELL;
  if(m.Type == INT || Type==INT ) return INT;
  if(m.Type == CHAR || Type==CHAR ) return CHAR;
  return NONE;
}

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse VariablenInhalt
    ------------------------------------------
    void ::Set(VarType Type=NONE, int Level=0, double rInhalt=0, char *m=NULL)

    - Beschreibung
    --------------
    Setzen des Inhaltes

    - Parameter
    -----------
    E:s.o.        Alle Eingangsgroessen zum Setzen des Inhaltes !

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    VarTyp, groesster Variablentyp

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/

void VariablenInhalt::Set(VarType Type, int Level, double rInhalt, char *m)
{
  VariablenInhalt::Level=Level;
  VariablenInhalt::Type=Type;
  VariablenInhalt::rInhalt=rInhalt;
  VariablenInhalt::strInhalt=m;
}

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Zuweisungsoperator der Klasse TokenType
    ------------------------------------------
    TokenType& ::operator=(const TokenType &m)

    - Beschreibung
    --------------
    Zuweisung

    - Parameter
    -----------
    E: m         Die zuzuweisende Instanz

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    Referenz auf *this

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
TokenType& TokenType::operator=(const TokenType &m)
{
  if(this!=&m) {
    UnionType=m.UnionType;
    VarVal=m.VarVal;
    #ifndef __OLD_INTERPRETE__
      ObjUnionType=m.ObjUnionType;
    #endif
  }
  return *this;
}

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse HashStrClass
    ------------------------------------------
    int ::HashFunktion(const StrClass &Str) const

    - Beschreibung
    --------------
    Bildet StrClassElemente Auf ein Array von SortListe<StrClass>
    ab.

    - Parameter
    -----------
    E:Str  : Den abzubildenden String

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    Einen Indexwert

    - Historie
    ----------
    12.8.1994 Horst Hogenkamp & Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int HashStrClass::HashFunktion(const StrClass &Str) const
{
  const char *str=Str.GetStrPtr();
  int last = strlen(str)-1;

  if (last<=2) return(str[0]);
  if (str[last]=='2'){
      return((str[0]<<0)^(str[1]<<5)^(str[2]<<11)^(str[last-2]<<13));
  } else {
      return((str[0]<<0)^(str[1]<<5)^(str[2]<<11)^(str[last]<<13));
  }
}

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Konstruktoren der Klasse LevelVariablen
    ------------------------------------------
    LevelVariablen::LevelVariablen(int Level)
    LevelVariablen::LevelVariablen(const LevelVariablen *ptrVars)

    - Beschreibung
    --------------
    kopieren

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    E: Vars    : Die Quellvariablen ..

    - Returncode
    ------------
    keinen

    - Historie
    ----------
    11.5.1994 Sven Goethel
    09.8.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
LevelVariablen::LevelVariablen(int Level)
: Level(Level), VarNamen(Level==0?197:1)
{}

LevelVariablen::LevelVariablen(const LevelVariablen &Vars)
: VarNamen(0), VarInhalt()
{ Copy(&Vars); }

LevelVariablen::LevelVariablen(const LevelVariablen *ptrVars)
: VarNamen(0), VarInhalt()
{
  if(ptrVars!=NULL) Copy(ptrVars);
  else INT_ERR(__LINE__);
}


/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse LevelVariablen
    ------------------------------------------
    void ::Copy(const LevelVariablen *Vars)

    - Beschreibung
    --------------
    kopieren

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    E: Vars    : Die Quellvariablen ..

    - Returncode
    ------------
    keinen

    - Historie
    ----------
    11.5.1994 Sven Goethel
    09.8.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
void LevelVariablen::Copy(const LevelVariablen *Vars)
{
  Level=Vars->Level;
  VarNamen=Vars->VarNamen;
  VarInhalt=Vars->VarInhalt;
}

/***************************************************************************/
/***************************************************************************/


/*DOCST------------------------------------------------------------------------------

    Konstruktoren der Klasse Variablen
    ------------------------------------------
    ::Variablen(const Variablen *ptrVars)
    ::Variablen(const Variablen &Vars)
    ::Variablen &operator=(const Variablen &Vars)

    - Beschreibung
    --------------
    verschieden konstruktoren

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keinen

    - Historie
    ----------
    11.5.1994 Sven Goethel
    09.8.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
Variablen::Variablen(const Variablen *ptrVars)
{
  if(ptrVars!=NULL) LevelVariablenListe=ptrVars->LevelVariablenListe;
}
Variablen::Variablen(const Variablen &Vars)
{
  LevelVariablenListe=Vars.LevelVariablenListe;
}
Variablen &Variablen::operator=(const Variablen &Vars)
{
  LevelVariablenListe=Vars.LevelVariablenListe;
  return *this;
}

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse Variablen
    ------------------------------------------
    [1] void ::Dest()
    [2] void ::ClearVarDefOrder()

    - Beschreibung
    --------------
    [1] loeschen aller inhalte
    [2] loeschen der Variablen Reihenfolge !!!

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keinen

    - Historie
    ----------
    11.5.1994 Sven Goethel
    09.8.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
void Variablen::Dest(void)
{
  while ( LevelVariablenListe.laenge() > 0 )  LevelVariablenListe.loesche(0);
}

#ifdef __OLD_INTERPRETE__
	void Variablen::ClearVarDefOrder()
	{
		while(VarDefOrder.laenge()>0) VarDefOrder.loesche(0);
	}
# endif

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse Variablen
    ------------------------------------------
    VariablenInhalt *::DeRefVar ( int LevelVon, int LevelBis, const char *VarName )

    - Beschreibung
    --------------
    Dereferenziert eine Variablen inkl. Gueltigkeitsbereich....

    - Parameter
    -----------
    E:LevelVon    :   GueltigkeitsBereich [LevelVon..LevelBis]
    E:LevelBis  :   GueltigkeitsBereich [LevelVon..LevelBis]
    E:VarName    :     Variablen Name

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    Pointer zu VarInhalt falls gefunden,
    sonst NULL.

    - Historie
    ----------
    11.5.1994 Sven Goethel
    09.8.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
VariablenInhalt *Variablen::DeRefVar ( int LevelVon, int LevelBis, const char *VarName )
{
  int i=0, LevelCount;
  VariablenInhalt *result=NULL;

  for ( LevelCount=LevelBis; result==NULL && LevelCount>=LevelVon; LevelCount--)
  {
    for ( i=LevelVariablenListe.laenge()-1;
          i>=0 && LevelVariablenListe[i]!=LevelCount;
          i--
        ) ;
    if ( i >= 0 )
    {
      int j=LevelVariablenListe[i].VarNamen.findeElement(VarName);
      if ( j >= 0 ) result=&(LevelVariablenListe[i].VarInhalt[j]);
    }
  }

  return result;
}


/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse Variablen
    ------------------------------------------
    int ::HoleWert ( int Level, const char *VarName , VariablenInhalt &VarInhalt)

    - Beschreibung
    --------------
    Holt den Wert einer Variable VarName in die Variable mit der Referenz
    Inhalt. Der Variablentyp wird in die Variable mit der Referenz type
    abgelegt.

    - Parameter
    -----------
    E:Level           :    Gueltigkeitsbereich
    E:VarName       :     Variablen Name
    A:ptrVarInhalt :     Referenz auf eine Variable, welche die Referenz
                        des Variablen-Inhaltes aufnehmen soll.

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int Variablen::HoleWert ( int Level, const char *VarName , VariablenInhalt &VarInhalt)
{
  VariablenInhalt *ptrVarValue=DeRefVar ( 0, Level, VarName );

  if(ptrVarValue!=NULL)
  {
    VarInhalt=*ptrVarValue;
    return 1;
  }
  return 0;
}

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse Variablen
    ------------------------------------------
    int ::SetzeWert ( int Level, const char *VarName , const VariablenInhalt &VarInhalt)


    - Beschreibung
    --------------
    Inhalt einer Variable setzen.
    Gueltigkeitbereich ab Level.
    Typenueberpruefung auf STRING <=> INT,REELL,CHAR !!!

    - Parameter
    -----------
    R: Level        Gueltigkeitsbereich der zu setzenden Variable
    E: VarName        VariablenName
    E:VarInhalt :     Variablen-Inhalt

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int Variablen::SetzeWert ( int Level, const char *VarName , const VariablenInhalt &VarInhalt)
{
  VariablenInhalt *ptrVarValue=DeRefVar ( 0, Level, VarName );

  if(ptrVarValue!=NULL)
  {
    // TypeCasting, ausser STRING -> Zahl ... (INT,REELL,...)
    if( ( (*ptrVarValue).Type==STRING && VarInhalt.Type!=STRING ) ||
        ( VarInhalt.Type==STRING && (*ptrVarValue).Type!=STRING )
      ) return 0;
    // Nur die Inhalte Kopieren :
    ptrVarValue->rInhalt=VarInhalt.rInhalt;
    ptrVarValue->strInhalt=VarInhalt.strInhalt;
    return 1;
  }
  return 0;
}

#ifdef __OLD_INTERPRETE__
	/*DOCST------------------------------------------------------------------------------

			Elementfunktion der Klasse Variablen
			------------------------------------------
			int ::SetzeWerte ( int Level, Liste<VariablenInhalt> &ArgListe)

			- Beschreibung
			--------------
			Die letzten auf den Variablen Stack befindlichen Variablen
			mittels ArgListe Setzen !!!!
			Inklusive STRING-Typenkontrolle und Level-Kontrolle !!!!

			- Parameter
			-----------
			E:Level        Aktueller Level
			E:ArgListe  die VariablenInhalte !!!

			- allgemeine Ein- und Ausgabeeinheiten
			--------------------------------------
			keine

			- Returncode
			------------
			0 - Fehler
			1 - Ok

			- Historie
			----------
			11.5.1994 Sven Goethel

	------------------------------------------------------------------------------DOCEND*/
	int Variablen::SetzeWerte ( int Level, Liste<VariablenInhalt> &ArgListe)
	{
		if(ArgListe.laenge()==0) return 1;

		for ( int lvi=LevelVariablenListe.laenge()-1;
					lvi>=0 && LevelVariablenListe[lvi]!=Level;
					lvi--
				) ;
		if ( lvi < 0 )
		{
			fprintf(stderr, "<CALC> Level bei SetzeWerte nicht gefunden !\n");
			return 0;
		}
		// ParameterAnzahl ist falsch !!!!
		if(ArgListe.laenge()>LevelVariablenListe[lvi].VarInhalt.laenge())
		{
			fprintf(stderr,"<CALC> Zu viele uebergebene Parameter !\n");
			return 0;
		}
		// Die Variablen-Definitions-Reihenfolge ist fehlerhaft !!!!
		if(VarDefOrder.laenge()!=LevelVariablenListe[lvi].VarInhalt.laenge())
		{
			fprintf(stderr,"<CALC> Fehlerhafte Parameterreihenfolge (INTERNER FEHLER) !\n");
			return 0;
		}

		// Die zum Level gehoerigen Variablen der ArgListe uebertragen !!!
		for(int i=0; i<ArgListe.laenge()&&ArgListe[i].Level==Level; i++)
		{
			// TypeCasting, ausser STRING -> Zahl ... (INT,REELL,...)
			int j=LevelVariablenListe[lvi].VarNamen.findeElement(VarDefOrder[i]);
			if(j<0)
			{
				fprintf(stderr,"<CALC> Fehlerhafte Parameternamen (INTERNER FEHLER) !\n");
				return 0;
			}
			if( ( LevelVariablenListe[lvi].VarInhalt[j].Type==STRING
						&& ArgListe[i].Type!=STRING
					) ||
					( ArgListe[i].Type==STRING &&
						LevelVariablenListe[lvi].VarInhalt[j].Type!=STRING
					)
				)
			{
				fprintf(stderr,"<CALC> Falscher Parameter-Typ : %s !\n",
					LevelVariablenListe[lvi].VarNamen[j].GetStrPtr());
				return 0;
			}
			// VarIABLEN NICHT FUER DIESEN LEVEL ???
			if( LevelVariablenListe[lvi].VarInhalt[j].Level!=Level )
			{
				fprintf(stderr,"<CALC> Falscher Gueltigkeitsbereich des Parameters : %s !\n",
					LevelVariablenListe[lvi].VarNamen[j].GetStrPtr());
				return 0;
			}
			// Nur die Inhalte Kopieren :
			LevelVariablenListe[lvi].VarInhalt[j].rInhalt=ArgListe[i].rInhalt;
			LevelVariablenListe[lvi].VarInhalt[j].strInhalt=ArgListe[i].strInhalt;
		}
		return 1;
	}
# endif

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse Variablen
    ------------------------------------------
    int ::DefiniereVar ( const char *VarName , const VariablenInhalt &VarInhalt)

    - Beschreibung
    --------------
    Definiert eine neue Variable mit bestimmten Inhalt
    Die Variable darf noch nicht definiert worden sein.

    - Parameter
    -----------
    E: VarName        VariablenName
    E: VarInhalt       Variablen-Inhalt

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok


    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int Variablen::DefiniereVar ( const char *VarName , const VariablenInhalt &VarVal)
{
  for ( int lvi=LevelVariablenListe.laenge()-1;
        lvi>=0 && LevelVariablenListe[lvi]!=VarVal.Level;
        lvi--
      ) ;

  // Falls Level noch nicht existiert einfuegen..
  if ( lvi < 0 ) LevelVariablenListe.fuegeEin(VarVal.Level, lvi=LevelVariablenListe.laenge());

  int j=LevelVariablenListe[lvi].VarNamen.findeElement(VarName);
  if ( j >= 0 )
  {
    // Variablen war schon definiert.... FEHLER
    return 0;
  }

  // Variable hinzufuegen .....
  int i=LevelVariablenListe[lvi].VarNamen.fuegeEin(VarName);
  if(i<0) INT_ERR(__LINE__);
  LevelVariablenListe[lvi].VarInhalt.fuegeEin(VarVal, i);
	#ifdef __OLD_INTERPRETE__
    VarDefOrder.fuegeEin(VarName);
  #endif

  return 1;
}

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse Variablen
    ------------------------------------------
    int ::Loesche ( int Level )

    - Beschreibung
    --------------
    Loescht alle Variablen >= Level  && Level > 0,
    da Level==0 ==> Globale Variable !!!

    - Parameter
    -----------
    E:Level        Gueltigkeitsbereich

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    Anzahl der geloeschten Variablen.


    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int Variablen::Loesche ( int Level )
{
  int Anzahl=0;

  if(Level>0)
  {
    for(int i=LevelVariablenListe.laenge()-1; i>=0; i--)
    {
      if(LevelVariablenListe[i].HoleLevel() >= Level)
      {
        LevelVariablenListe.loesche(i);
        Anzahl++;
      }
    }
  }

  return Anzahl;
}

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    ElementFunktion der Klasse LabelLocus
    --------------------------------------------
   int ::GetFilePos(const StrClass &Name, FilePosition &result)

    - Beschreibung
    --------------
    Einholen der FilePosition des Label-Names in der zu parsenden Datei

    - Parameter
    -----------
    E: Name        Label Name
    A: result   Die referenzierte Variable, in welcher das Resultat
                vorliegen soll.

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int LabelLocus::GetFilePos(const StrClass &Name, FilePosition &result)
{
    int i=Namen.istElement(Name);

    if(i>=0)
    {
      result = FilePos[i];
      return 1;
    } else {
      return 0;
    }
}

/*DOCST------------------------------------------------------------------------------

    ElementFunktion der Klasse LabelLocus
    --------------------------------------------
   int ::SetFilePos(const StrClass &Name, const FilePosition &fPos )

    - Beschreibung
    --------------
    Definieren der Fileposition eines Labels in der zu parsenden Datei

    - Parameter
    -----------
    E: Name        Label Name
    E: fPos     Die referenzierte Variable, in welcher die Fileposition,
                Bytenummer und ZeilenNummer, enthalten ist.

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int LabelLocus::SetFilePos(const StrClass &Name, const FilePosition &fPos )
{
  Namen.fuegeEin(Name);
  FilePos.fuegeEin(fPos);
  return 1;
}

/*DOCST------------------------------------------------------------------------------

    ElementFunktion der Klasse LabelLocus
    --------------------------------------------
   int ::laenge(void)

    - Beschreibung
    --------------
    Einholen der Laenge der Label-FilePositionen-Listen.

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    Die Laenge der Liste, bzw. Anzahl der eingetragenen FxmObjekte

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int LabelLocus::laenge(void)
{
  return Namen.laenge();
}

/*DOCST------------------------------------------------------------------------------

    ElementFunktion der Klasse LabelLocus
    --------------------------------------------
   int ::loesche(int i)

    - Beschreibung
    --------------
    Loeschen eines Labels-FilePositions-Eintrages mit dem Index i.

    - Parameter
    -----------
    E: i        Indexposition des Eintrages, beginnend mit 0.

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int LabelLocus::loesche(int i)
{
  int result;

  if ( ( result=Namen.loesche(i) ) > 0 )
  {
    result=FilePos.loesche(i);
  }
  return result;
}

/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Allgemeine globale Ausgabefunktion
    --------------------------------------------
    int Print(FILE *fPtr, char *str, Liste<VariablenInhalt> &ArgListe)

    - Beschreibung
    --------------
    Ausgabefunktion, welche sich an die 'fprintf' Funktion
    von ANSI-C haelt.

    - Parameter
    -----------
    A:fPtr            Ausgabedatei
    E:str            Der Auszugebende String (Nach ANSI-C)
    E:ArgListe        Die fuer den String, str, noetigen Argumente !!!

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Fehler
    1 - Ok

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int Print(FILE *fp, const char *format, Liste<VariablenInhalt> &ArgListe)
{
    const char *p = format;
    char fmt[256] = "";
    int i=0;
    int arg=ArgListe.laenge();
		#ifndef __OLD_INTERPRETE__
		  // In der neuen Datenstruktur sind die Argumente in der richtigen
			// Reihenfolge
		  int arg_idx=0;
    #endif

    while(*p!='\0')
    {
        if (*p!='%')
    		{
            fprintf(fp, "%c", *p++);
            continue;
        }
        #ifdef __OLD_INTERPRETE__
				  if (arg<=0)
				#else
				  if (arg_idx>=arg)
				#endif
    		{
            fprintf(stderr,
						  "<CALC> Fuer Print zu wenig Argumente uebergeben!\n");
            return 0;
        }
        fmt[i=0] = *(p++); // skip %
        while (strchr("+- 0123456789#.hlL",fmt[++i]=*(p++))!=NULL);
        fmt[i+1]='\0';
        switch(fmt[i])
    		{
            case 'd':
            case 'i':
            case 'o':
            case 'x':
            case 'X':
            case 'u':
            case 'c':    
												 #ifdef __OLD_INTERPRETE__ 
												   fprintf(fp, fmt, (int)(ArgListe[--arg].rInhalt));
												 #else
												   fprintf(fp, fmt, (int)(ArgListe[arg_idx++].rInhalt));
 												 #endif
                				 break;
            case 's':    
												 #ifdef __OLD_INTERPRETE__ 
												   fprintf(fp, fmt, 
													  (char *)(ArgListe[--arg].strInhalt.GetStrPtr()));
												 #else
												   fprintf(fp, fmt, 
													  (char *)(ArgListe[arg_idx++].strInhalt.GetStrPtr()));
 												 #endif
                				 break;
            case 'f':
            case 'e':
            case 'E':
            case 'g':
            case 'G':    
												 #ifdef __OLD_INTERPRETE__ 
												   fprintf(fp, fmt, 
													   (double)(ArgListe[--arg].rInhalt));
												 #else
												   fprintf(fp, fmt, 
													   (double)(ArgListe[arg_idx++].rInhalt));
 												 #endif
                				 break;
            case 'p':    fprintf(stderr, "<CALC> Print fuer Zeiger mit Format '%s' ist nicht implementiert!\n", fmt);
                return 0;
            // this case is basically equal to the default case
            case '%':    fprintf(fp, "%%");
                break;
            default:    fprintf(fp, "%s", fmt);
                break;
        }
    }
    return 1;
}

/***************************************************************************/
/***************************************************************************/



