/*************************************************************************/
/*
 *  Datei           : calctokn.h
 *  Inhalt          : Deklarationen der Klassen :
 *                        o FilePosition
 *                        o VariablenInhalt
 *                        o Variablen
 *                        o CalcObjectDefLocus
 *                      Weitere Deklarationen :
 *                        o Print
 *                        o YYSTYPE
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 06.07.1994
 *  nderungsdatum  : 14.12.1994
 *  Projekt         : calc
 *  Verzeichnis     :
 *  Dokumentation   : calc.doc
 *
 *
 * $Log: calctokn.h  $
 * Revision 2.26  1995/06/06 08:48:26  Sven_Goethel_DFP
 * ok
 * Revision 2.25  1995/06/06 08:20:24  Sven_Goethel_DFP
 * lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
 * Revision 2.24  1995/04/07 11:35:10  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:39  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:25  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:18  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:41:32  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:07:44  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.2  1995/01/30 08:17:58  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.1  1995/01/27 17:45:02  Sven_Goethel
 * Initial revision
 * Revision 1.1  1994/12/16 16:52:07  Sven_Goethel
 * Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# ifndef _CALCTOKN_H
  # define _CALCTOKN_H

  # include <stdio.h>
  # include <math.h>
  # include "liste.h"
  # include "strclass.h"
  # include "maschine.h"
  # include "sortlist.h"
  # include "hashlist.h"
  # include "calctype.h"

  /*
  typedef TokenType YYSTYPE;     -->  wird am Ende dieser Datei deklariert ...
  # include "lex_yy.hpp"         -->  wird am Ende dieser Datei eingebunden ...
  # include "ytab.hpp"           -->  wird am Ende dieser Datei eingebunden ...
  */

  # ifndef NDEBUG
    # define DPRINT(a) printf((a))
  # else
    # define DPRINT(a)
  # endif
  # ifndef M_PI
    # define M_PI        3.14159265358979323846
  #endif

  typedef union {
    double dval;                /* double Wert. */
    FilePosition FilePos;       /* FilePos fuer while,... */
    VarType varType;            /* VariablenTyp */
  } TokenUnionType;

	#ifndef __OLD_INTERPRETE__
	  typedef union {
		  Anweisungen * pAnweisungen;
		  Anweisung * pAnweisung;
			Ausdruck *pAusdruck;
			Produkt *pProdukt;
			Operand *pOperand;
			DeepRefListe<Ausdruck> *pAusdruckRefListe;
			Zuweisung	*pZuweisung;
			DeepRefListe<Zuweisung> * pZuweisungRefListe;
			DeepRefListe<VariablenDef> * pVarDefRefListe;
      VariablenDef * pVarDef;
    } ObjTokenUnionType;
  #endif

  class TokenType {
  public:
    TokenType(void) 
		: VarVal() { }
    TokenType(const TokenType &m)
    : UnionType(m.UnionType), VarVal(m.VarVal) 
	    #ifndef __OLD_INTERPRETE__
			  , ObjUnionType(m.ObjUnionType)
      #endif
    {}
    TokenType& operator=(const TokenType &m);

    TokenUnionType  UnionType;
    VariablenInhalt VarVal;
	  #ifndef __OLD_INTERPRETE__
		  ObjTokenUnionType ObjUnionType;
    #endif
  };

  // Deklaration fuer den FxmConverterInterpreter, y_tab.* !!!!!
  typedef TokenType YYSTYPE;

  # include "lex_yy.hpp"
  # include "ytab.hpp"

# endif


