/* e:\work\mks\bin\yacc -l -LC -o ytab.cc -P calcpars.mks calc.y */
#ifdef YYTRACE
#define YYDEBUG 1
#else
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#endif

/*************************************************************************/
/*
 *  Datei           : calc.y
 *  Inhalt          : Grammatik des Calculators
 *                      Diese Grammmatik ist fuer MKS-YACC bestimmt,
 *                      uns zwar fuer den -LC Mode (C++).
 *                      und mit der Skelett-Datei "calcpars.mks"
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 06.07.1994
 *  nderungsdatum  : 14.12.1994
 *  Projekt         : calc
 *  Verzeichnis     :
 *  Dokumentation   : calc.doc
 *
 *
 * $Log: calc.y  $
 * Revision 2.24  1995/04/07 11:35:04  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:35  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:10  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:09  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:41:40  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:08:15  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.3  1995/01/30 08:18:25  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.2  1995/01/27 17:45:31  Sven_Goethel
 * break - 
 * Revision 1.1  1994/12/16 16:52:04  Sven_Goethel
 * Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# include "calc_y.h"

/* Vereinfachung fuer die Synthese des Parsers.
   D.h. yacc von mks erzeugt YY_Types (enum) der Token Types,
   welche fuer den YYDEBUG Modus Verwendung finden.
   Diese YY_Types-Namen duerfen aber keinen Struktur-Dereferenzierer
   enthalten, also keinen Punkt <StrukturName>.<StrukturElement> !!!
*/
#define _FILEPOS_     UnionType.FilePos
#define _VARTYPE_     UnionType.varType
#define _VARVAL_    	VarVal
#define _DVAL_				UnionType.dval

#ifndef __OLD_INTERPRETE__
	#define _P_ANWEISUNGEN_ 			ObjUnionType.pAnweisungen
	#define _P_ANWEISUNG_ 				ObjUnionType.pAnweisung
	#define _P_AUSDRUCK_ 					ObjUnionType.pAusdruck
	#define _P_PRODUKT_ 					ObjUnionType.pProdukt
	#define _P_OPERAND_ 					ObjUnionType.pOperand
	#define _P_ZUW_REF_LIST_ 			ObjUnionType.pZuweisungRefListe
	#define _P_AUSDRUCK_REF_LIST_ ObjUnionType.pAusdruckRefListe
	#define _P_ZUWEISUNG_ 				ObjUnionType.pZuweisung
	#define _P_VARDEF_REF_LIST_ 	ObjUnionType.pVarDefRefListe
	#define _P_VAR_DEF_ 					ObjUnionType.pVarDef

	#define _TYPE_1_ _P_OPERAND_
	#define _TYPE_2_ _VARVAL_
	#define _TYPE_3_ _P_PRODUKT_
	#define _TYPE_4_ _P_ANWEISUNG_
	#define _TYPE_5_ _P_AUSDRUCK_
	#define _TYPE_6_ _P_ANWEISUNGEN_
	#define _TYPE_7_ _P_OPERAND_
	#define _TYPE_8_ _P_ZUW_REF_LIST_
	#define _TYPE_9_ _P_ZUWEISUNG_
	#define _TYPE_10_ _P_AUSDRUCK_REF_LIST_
	#define _TYPE_11_ _P_VARDEF_REF_LIST_
	#define _TYPE_12_ _P_VAR_DEF_
#else
	#define _TYPE_1_ _VARVAL_
	#define _TYPE_2_ _VARVAL_
	#define _TYPE_3_ _VARVAL_
	#define _TYPE_4_ _VARVAL_
	#define _TYPE_5_ _VARVAL_
	#define _TYPE_6_ _VARVAL_
	#define _TYPE_7_ _VARVAL_
	#define _TYPE_8_ _DVAL_
	#define _TYPE_9_ _DVAL_
	#define _TYPE_10_ _DVAL_
	#define _TYPE_11_ _DVAL_
	#define _TYPE_12_ _DVAL_
#endif

// YYSTYPE declared in fxmcnv_y.h !!!!!
// ==> typedef TokenType YYSTYPE;

YYSTYPE yylval;  /* yy_scan sets this ..... allready extern declared */

extern YYSTYPE yylval;
#if YYDEBUG
enum YY_Types { YY_t_NoneDefined, YY_t__FILEPOS_, YY_t__VARVAL_, YY_t__VARTYPE_, YY_t__TYPE_1_, YY_t__TYPE_2_, YY_t__TYPE_3_, YY_t__TYPE_5_, YY_t__TYPE_7_, YY_t__TYPE_4_, YY_t__TYPE_6_, YY_t__TYPE_8_, YY_t__TYPE_9_, YY_t__TYPE_10_, YY_t__TYPE_11_, YY_t__TYPE_12_
};
#endif
#if YYDEBUG
yyTypedRules yyRules[] = {
	{ "&00: %39 &00",  0},
	{ "%41:",  0},
	{ "%39: %40 %41 %42",  0},
	{ "%43:",  0},
	{ "%40: &19 %43 %44 &04",  0},
	{ "%45:",  0},
	{ "%46:",  0},
	{ "%42: &19 &52 &09 &06 &53 %45 %25 %46 %47 &04 &53",  0},
	{ "%47:",  0},
	{ "%47: %48",  0},
	{ "%48: %49",  0},
	{ "%48: %48 %49",  0},
	{ "%44:",  0},
	{ "%44: %50",  0},
	{ "%50: %51",  0},
	{ "%50: %50 %51",  0},
	{ "%51: &05 &09 &18",  0},
	{ "%25:",  10},
	{ "%25: %26",  10},
	{ "%26: %14",  10},
	{ "%26: %26 %14",  10},
	{ "%14: %15",  9},
	{ "%14: %16",  9},
	{ "%14: %17",  9},
	{ "%15: %08 &53",  9},
	{ "%15: %18 &53",  9},
	{ "%15: %12 &53",  9},
	{ "%15: %19 &53",  9},
	{ "%15: %20",  9},
	{ "%15: %23",  9},
	{ "%19: &20 &52 %04 &06",  9},
	{ "%52:",  0},
	{ "%20: &54 %52 %26 &55",  9},
	{ "%53:",  0},
	{ "%18: %36 %53 %28",  9},
	{ "%54:",  0},
	{ "%18: &23 %36 %54 %28",  9},
	{ "%28: %29",  11},
	{ "%28: %28 &56 %29",  11},
	{ "%29: &09",  12},
	{ "%29: &09 &24 %55 %04",  12},
	{ "%55:",  0},
	{ "%36: &11",  3},
	{ "%36: &12",  3},
	{ "%36: &13",  3},
	{ "%36: &14",  3},
	{ "%12: &17 &52 &08 %30 &06",  9},
	{ "%30:",  13},
	{ "%30: &56 %32",  13},
	{ "%31:",  13},
	{ "%31: %32",  13},
	{ "%32: %24",  13},
	{ "%32: %32 &56 %24",  13},
	{ "%24: %04",  7},
	{ "%56:",  0},
	{ "%57:",  0},
	{ "%16: &15 &52 %04 &06 %56 %15 %57 %13",  9},
	{ "%13:",  9},
	{ "%58:",  0},
	{ "%13: &16 %58 %14",  9},
	{ "%17: %21",  9},
	{ "%17: %22",  9},
	{ "%59:",  0},
	{ "%21: &02 &52 %04 &06 %59 %14",  9},
	{ "%60:",  0},
	{ "%22: &03 %60 %14 &02 &52 %04 &06 &53",  9},
	{ "%10: %27 %49",  8},
	{ "%10: %27",  8},
	{ "%61:",  0},
	{ "%27: &09 &52 %61 %31 &06",  8},
	{ "%62:",  0},
	{ "%63:",  0},
	{ "%49: &05 &09 %62 &52 %33 &06 %37 &53 %63 %25 &18 &53",  0},
	{ "%33:",  14},
	{ "%33: %34",  14},
	{ "%34: %35",  14},
	{ "%34: %34 &56 %35",  14},
	{ "%35: %36 %29",  15},
	{ "%37:",  3},
	{ "%37: %38",  3},
	{ "%38: &57 %36",  3},
	{ "%23: &22 %08 &53",  9},
	{ "%08:",  7},
	{ "%08: %04",  7},
	{ "%04: %09",  7},
	{ "%04: %06",  7},
	{ "%04: %07",  7},
	{ "%04: %05",  7},
	{ "%05: %04 &26 %04",  7},
	{ "%05: %04 &25 %04",  7},
	{ "%06: %04 &27 %04",  7},
	{ "%06: %04 &30 %04",  7},
	{ "%06: %04 &29 %04",  7},
	{ "%06: %04 &31 %04",  7},
	{ "%06: %04 &32 %04",  7},
	{ "%06: %04 &28 %04",  7},
	{ "%07: &09 &24 %04",  7},
	{ "%07: &09 &58 %04 &59 &24 %04",  7},
	{ "%09: %03",  7},
	{ "%09: %04 &33 %03",  7},
	{ "%09: %04 &34 %03",  7},
	{ "%03: %01",  6},
	{ "%03: %03 &35 %01",  6},
	{ "%03: %03 &36 %01",  6},
	{ "%03: %03 &44 %01",  6},
	{ "%03: &43 &52 %04 &56 %04 &06",  6},
	{ "%01: %02",  4},
	{ "%01: &08",  4},
	{ "%01: %10",  4},
	{ "%01: %11",  4},
	{ "%01: &37 %01",  4},
	{ "%01: &38 %01",  4},
	{ "%01: &39 %01",  4},
	{ "%01: &40 %01",  4},
	{ "%01: &41 %01",  4},
	{ "%01: &42 %01",  4},
	{ "%01: &45 %01",  4},
	{ "%01: &46 %01",  4},
	{ "%01: &47 %01",  4},
	{ "%01: &48 %01",  4},
	{ "%01: &49 %01",  4},
	{ "%01: &51 %01",  4},
	{ "%01: &52 %04 &06",  4},
	{ "%01: &10",  4},
	{ "%01: &50 %01",  4},
	{ "%02: &07",  5},
	{ "%02: &07 &57 &07",  5},
	{ "%02: &33 &07",  5},
	{ "%02: &34 &07",  5},
	{ "%11: &09",  8},
	{ "%11: &09 &58 %04 &59",  8},
{ "$accept",  0},{ "error",  0}
};
yyNamedType yyTokenTypes[] = {
	{ "$end",  0,  0},
	{ "error",  256,  0},
	{ "T_WHILE",  257,  1},
	{ "T_DO",  258,  1},
	{ "T_CALC_END",  259,  1},
	{ "T_FUNC_DEF",  260,  1},
	{ "')'",  41,  1},
	{ "T_ZAHL",  261,  2},
	{ "T_STRING",  262,  2},
	{ "T_BEZEICHNER",  263,  2},
	{ "T_ANYCHAR",  264,  2},
	{ "T_VARTYP_INT",  265,  3},
	{ "T_VARTYP_REELL",  266,  3},
	{ "T_VARTYP_CHAR",  267,  3},
	{ "T_VARTYP_STRING",  268,  3},
	{ "T_IF",  269,  0},
	{ "T_ELSE",  270,  0},
	{ "T_PRINTF",  271,  0},
	{ "T_FUNC_DEF_END",  272,  0},
	{ "T_CALC_START",  273,  0},
	{ "T_EXIT",  274,  0},
	{ "T_ERROR",  275,  0},
	{ "T_RETURN",  276,  0},
	{ "T_GLOBAL",  277,  0},
	{ "'='",  61,  0},
	{ "T_ODER",  278,  0},
	{ "T_UND",  279,  0},
	{ "T_GLEICH",  280,  0},
	{ "T_UNGLEICH",  281,  0},
	{ "T_GROESSER",  282,  0},
	{ "T_GROESSERGLEICH",  283,  0},
	{ "T_KLEINER",  284,  0},
	{ "T_KLEINERGLEICH",  285,  0},
	{ "'+'",  43,  0},
	{ "'-'",  45,  0},
	{ "'*'",  42,  0},
	{ "'/'",  47,  0},
	{ "T_SIN",  286,  0},
	{ "T_COS",  287,  0},
	{ "T_TAN",  288,  0},
	{ "T_ARCSIN",  289,  0},
	{ "T_ARCCOS",  290,  0},
	{ "T_ARCTAN",  291,  0},
	{ "T_POW",  292,  0},
	{ "'^'",  94,  0},
	{ "T_LOG",  293,  0},
	{ "T_LOG10",  294,  0},
	{ "T_EXP",  295,  0},
	{ "T_SQRT",  296,  0},
	{ "T_NEG",  297,  0},
	{ "'!'",  33,  0},
	{ "T_ABS",  298,  0},
	{ "'('",  40,  0},
	{ "';'",  59,  0},
	{ "'{'",  123,  0},
	{ "'}'",  125,  0},
	{ "','",  44,  0},
	{ "':'",  58,  0},
	{ "'['",  91,  0},
	{ "']'",  93,  0}

};
#endif
static short yydef[] = {

	  -1,   -5,  129,   -9,   34,   31,   20,  -17,   35,   15, 
	 -21,   35,  -31,  -35,  -39,   33,   32,   28,   27,   26, 
	  25,   24,   23,   22,   21,   29,  -43,  -47,    7,    5, 
	 -51,  131,   36,   13,   12,    6,  -55,  -59,  -63,   10, 
	  30,   17,    8,  -67,   14,  -71,  -75
};
static short yyex[] = {

	   0,    0,   -1,    1,  259,  130,   -1,    1,  259,    3, 
	 260,    3,   59,   19,   -1,    1,   59,   19,   -1,    1, 
	 259,    4,  260,    4,  272,    4,   59,   19,   -1,    1, 
	  59,   19,   -1,    1,   59,   19,   -1,    1,  259,  132, 
	  -1,    1,   41,   11,   -1,    1,   41,    9,   -1,    1, 
	  59,   19,   -1,    1,   41,   16,   -1,    1,   59,   19, 
	  -1,    1,   59,   19,   -1,    1,   59,   18,   -1,    1, 
	  59,   19,   -1,    1,  272,    3,   59,   19,   -1,    1
};
static short yyact[] = {

	-225,  273, -137,  260, -135,  273, -134,  263, -224,  259, 
	-133,   40, -221,  272, -132,  263, -131,   41, -223,   59, 
	-128, -127, -129, -130, -208, -113, -185,   -5, -161,   -9, 
	-145, -201, -200, -199, -198, -112, -111, -109,   -8, -110, 
	-115, -116, -117, -118, -119, -120, -114, -121, -122, -123, 
	-124, -125, -126,  298,  297,  296,  295,  294,  293,  292, 
	 291,  290,  289,  288,  287,  286,  277,  276,  274,  271, 
	 269,  268,  267,  266,  265,  264,  263,  262,  261,  258, 
	 257,  123,   45,   43,   40,   33, -141,  261, -142,  261, 
	-104,   58, -128, -127, -129, -130,   -5, -161,  -12, -145, 
	-115, -116, -117, -118, -119, -120, -121, -122, -123, -124, 
	-125, -126,  298,  297,  296,  295,  294,  293,  291,  290, 
	 289,  288,  287,  286,  264,  263,  262,  261,   45,   43, 
	  40,   33, -128, -127, -129, -130,   -5, -161,   -9, -145, 
	-115, -116, -117, -118, -119, -120, -114, -121, -122, -123, 
	-124, -125, -126,  298,  297,  296,  295,  294,  293,  292, 
	 291,  290,  289,  288,  287,  286,  264,  263,  262,  261, 
	  45,   43,   40,   33, -102,   40,  -99, -100, -101,   94, 
	  47,   42,  -97,  -98,  -90,  -89,  -91,  -96,  -93,  -92, 
	 -94,  -95,  285,  284,  283,  282,  281,  280,  279,  278, 
	  45,   43, -182,  -86,  -87,   91,   61,   40,  -85,  260, 
	 -84,   40,  -83,   40,  -82,   40, -201, -200, -199, -198, 
	 268,  267,  266,  265,  -80,   40, -212,   59, -213,   59, 
	-214,   59, -215,   59, -143,  261, -182,  -79,   91,   40, 
	-146,  -97,  -98,  -90,  -89,  -91,  -96,  -93,  -92,  -94, 
	 -95,  285,  284,  283,  282,  281,  280,  279,  278,   45, 
	  43,   41, -128, -127, -129, -130,   -5, -161,  -12, -145, 
	-115, -116, -117, -118, -119, -120, -114, -121, -122, -123, 
	-124, -125, -126,  298,  297,  296,  295,  294,  293,  292, 
	 291,  290,  289,  288,  287,  286,  264,  263,  262,  261, 
	  45,   43,   40,   33, -172,   59, -180,  263,  -28,  262, 
	 -29,  263,  -97,  -69,  -98,  -90,  -89,  -91,  -96,  -93, 
	 -92,  -94,  -95,  285,  284,  283,  282,  281,  280,  279, 
	 278,   45,   44,   43,  -97,  -98,  -93,  -92,  -94,  -95, 
	 285,  284,  283,  282,   45,   43,  -97,  -98,   45,   43, 
	 -97,  -98,  -89,  -91,  -96,  -93,  -92,  -94,  -95,  285, 
	 284,  283,  282,  281,  280,  279,   45,   43,  -97,  -98, 
	 -91,  -96,  -93,  -92,  -94,  -95,  285,  284,  283,  282, 
	 281,  280,   45,   43,  -97,  -98,  -33,  -90,  -89,  -91, 
	 -96,  -93,  -92,  -94,  -95,  285,  284,  283,  282,  281, 
	 280,  279,  278,   93,   45,   43,  -66,  257, -187,  -97, 
	 -98,  -90,  -89,  -91,  -96,  -93,  -92,  -94,  -95,  285, 
	 284,  283,  282,  281,  280,  279,  278,   45,   43,   41, 
	-194,  -97,  -98,  -90,  -89,  -91,  -96,  -93,  -92,  -94, 
	 -95,  285,  284,  283,  282,  281,  280,  279,  278,   45, 
	  43,   41,  -65,   44, -202,   61,  -63,   44, -128, -127, 
	-129, -130, -208, -207, -113, -185,   -5, -161,   -9, -145, 
	-201, -200, -199, -198, -112, -111, -109,   -8, -110, -115, 
	-116, -117, -118, -119, -120, -114, -121, -122, -123, -124, 
	-125, -126,  298,  297,  296,  295,  294,  293,  292,  291, 
	 290,  289,  288,  287,  286,  277,  276,  274,  271,  269, 
	 268,  267,  266,  265,  264,  263,  262,  261,  258,  257, 
	 125,  123,   45,   43,   40,   33, -209,  -97,  -98,  -90, 
	 -89,  -91,  -96,  -93,  -92,  -94,  -95,  285,  284,  283, 
	 282,  281,  280,  279,  278,   45,   43,   41,  -62,  259, 
	 -97,  -98, -140,  -90,  -89,  -91,  -96,  -93,  -92,  -94, 
	 -95,  285,  284,  283,  282,  281,  280,  279,  278,   93, 
	  45,   43,  -60,   61, -181,   41,  -59,   44,  -37,   40, 
	 -58,   40, -197,   41, -228,   59, -163,  -97,  -98,  -90, 
	 -89,  -91,  -96,  -93,  -92,  -94,  -95,  285,  284,  283, 
	 282,  281,  280,  279,  278,   45,   43,   41, -128, -127, 
	-129, -130, -208,   -5, -161,   -9, -145, -201, -200, -199, 
	-198, -111, -109,   -8, -110, -115, -116, -117, -118, -119, 
	-120, -114, -121, -122, -123, -124, -125, -126,  298,  297, 
	 296,  295,  294,  293,  292,  291,  290,  289,  288,  287, 
	 286,  277,  276,  274,  271,  268,  267,  266,  265,  264, 
	 263,  262,  261,  123,   45,   43,   40,   33,  -53,   44, 
	 -44,   41,  -52,  -97,  -98,  -90,  -89,  -91,  -96,  -93, 
	 -92,  -94,  -95,  285,  284,  283,  282,  281,  280,  279, 
	 278,   45,   43,   41,  -51,   58, -184,   59, -191,  270, 
	-179,   59,  -48,  272, -178,   59,   -1
};
static short yypact[] = {

	   2,    3,    3,   53,   91,  179,  192,  153,  205,  209, 
	  53,  238,   53,   53,  209,  179,  179,  340,  348,  348, 
	 348,  348,  340,  359,  376,  192,  153,  453,  455,  457, 
	 492,  209,  573,  192,  577,  457,  220,   53,  638,  577, 
	 192,  669,  192,  695,  699,   53,   53,  705,  703,  701, 
	 220,  697,  220,  683,  671,  311,  153,  153,  153,  153, 
	 597,  585,  311,  583,  153,  581,  579,  575,  153,  561, 
	 549,  537,  311,  441,  419,  407,  395,  323,  153,  153, 
	 311,  309,  153,  153,  307,  153,  153,  305,  153,  153, 
	 153,  153,  153,  153,  153,  153,  283,  283,  112,  112, 
	 112,  153,  251,  235,  233,  231,  229,  227,  225,  220, 
	 215,  213,  211,  175,  112,  112,  112,  112,  112,  112, 
	 112,  112,  112,  112,  112,  112,  153,  112,   89,   87, 
	  19,   17,   15,   13,   11,    9,    7,    5,    1
};
static short yygo[] = {

	-166, -165, -164, -158, -157, -156, -155, -154, -153, -152, 
	-151, -150, -149, -148, -147, -144, -167,  127,  125,  124, 
	 123,  122,  121,  120,  119,  118,  117,  116,  115,  114, 
	 100,   99,   98, -162,  -17,  -16,   -6,   97,   96,  -34, 
	 -43,  -54,  -34,  -41,  -34,  -61,  -70,  -72,  -74,  -75, 
	 -26,  -77,  -25,  -24,  -23,  -22,  -21,  -20,  -19,  -18, 
	 -78, -103,   -7,  126,  101,   95,   94,   93,   92,   91, 
	  90,   89,   88,   86,   85,   83,   82,   79,   78,   68, 
	  64,   59,   58,   57,   56,   26, -168, -170, -169,  -88, 
	-105,    7, -171, -160, -159, -107, -192, -219,  -76, -219, 
	-186, -190, -220,   45,   37,   30,   12,   10, -193, -218, 
	  38, -217, -216, -106, -108, -211, -189, -188, -210, -195, 
	-196,   58,  -49, -222,   46,  -31,  -11,   13,  -10,  -36, 
	 -30,   72, -175, -203, -204,   62,   55,  -64,  -68,  -40, 
	 -35,   64,  -55,  -42, -176, -177,   52,  -56, -173,  -56, 
	-205, -206,  109,   52,   50,   36,  -50, -174,   -1, -227, 
	-138, -226,   -2, -136,   -4,  -15,  -71,  -32, -229, -230, 
	-183,   31,   14,   -3, -232, -231,    2,  -14,  -81,  -73, 
	 -57,  -39,  -45,  -46,  -38,  -13,  -27,  -67,  -47,   -1
};
static short yypgo[] = {

	   0,    0,    0,  123,  123,  113,  113,  134,  134,  137, 
	 137,  138,  138,  120,   96,   93,  142,  142,  156,   90, 
	  90,   86,   86,   87,   87,   87,   87,   87,   87,   88, 
	  88,   92,   92,   92,   33,   94,   94,   33,   33,   33, 
	  16,   16,   16,   16,   16,   16,   16,   16,   16,   16, 
	  16,   16,   16,   16,   16,   16,   16,   16,   16,   36, 
	  36,   36,   36,   36,   62,   62,   62,   62,  118,  157, 
	 156,  145,  143,  143,  170,  188,  187,  128,  186,   93, 
	 117,  185,  116,  184,  112,  112,   96,  183,  111,  182, 
	 181,  140,  140,   95,  151,  151,  151,  151,  180,  130, 
	 130,  179,  178,  115,  177,  114,  109,  109,  109,  109, 
	 109,  109,  102,  102,  102,  126,  126,  175,  165,  164, 
	 159,  162,  158,  160,  161,  167,  167,  173,  173,  163, 
	 163,  166,  166,    0
};
static short yyrlen[] = {

	   0,    0,    0,    0,    1,    3,    4,    1,    4,    0, 
	   2,    0,    1,    1,    0,    1,    0,    1,    0,    0, 
	   1,    3,    3,    3,    3,    3,    3,    3,    3,    3, 
	   6,    1,    3,    3,    1,    1,    4,    2,    2,    3, 
	   2,    1,    3,    2,    2,    2,    2,    2,    2,    2, 
	   2,    2,    2,    2,    2,    1,    1,    1,    1,    6, 
	   3,    3,    3,    1,    1,    1,    1,    1,    3,    2, 
	   1,    2,    3,    1,   12,    0,    0,    5,    0,    2, 
	   8,    0,    6,    0,    1,    1,    3,    0,    8,    0, 
	   0,    3,    1,    5,    1,    1,    1,    1,    0,    3, 
	   1,    0,    0,    4,    0,    4,    1,    1,    2,    2, 
	   2,    2,    1,    1,    1,    2,    1,    3,    0,    0, 
	   4,    0,    3,    0,   11,    1,    2,    1,    2,    1, 
	   0,    1,    0,    2
};
#define YYS0	138
#define YYDELTA	103
#define YYNPACT	139
#define YYNDEF	47

#define YYr131	0
#define YYr132	1
#define YYr133	2
#define YYr17	3
#define YYr18	4
#define YYr34	5
#define YYr36	6
#define YYr39	7
#define YYr40	8
#define YYr47	9
#define YYr48	10
#define YYr49	11
#define YYr50	12
#define YYr53	13
#define YYr57	14
#define YYr67	15
#define YYr73	16
#define YYr74	17
#define YYr78	18
#define YYr82	19
#define YYr83	20
#define YYr88	21
#define YYr89	22
#define YYr90	23
#define YYr91	24
#define YYr92	25
#define YYr93	26
#define YYr94	27
#define YYr95	28
#define YYr96	29
#define YYr97	30
#define YYr98	31
#define YYr99	32
#define YYr100	33
#define YYr125	34
#define YYr129	35
#define YYr130	36
#define YYr128	37
#define YYr127	38
#define YYr126	39
#define YYr124	40
#define YYr123	41
#define YYr122	42
#define YYr121	43
#define YYr120	44
#define YYr119	45
#define YYr118	46
#define YYr117	47
#define YYr116	48
#define YYr115	49
#define YYr114	50
#define YYr113	51
#define YYr112	52
#define YYr111	53
#define YYr110	54
#define YYr109	55
#define YYr108	56
#define YYr107	57
#define YYr106	58
#define YYr105	59
#define YYr104	60
#define YYr103	61
#define YYr102	62
#define YYr101	63
#define YYr87	64
#define YYr86	65
#define YYr85	66
#define YYr84	67
#define YYr81	68
#define YYr80	69
#define YYr79	70
#define YYr77	71
#define YYr76	72
#define YYr75	73
#define YYr72	74
#define YYr71	75
#define YYr70	76
#define YYr69	77
#define YYr68	78
#define YYr66	79
#define YYr65	80
#define YYr64	81
#define YYr63	82
#define YYr62	83
#define YYr61	84
#define YYr60	85
#define YYr59	86
#define YYr58	87
#define YYr56	88
#define YYr55	89
#define YYr54	90
#define YYr52	91
#define YYr51	92
#define YYr46	93
#define YYr45	94
#define YYr44	95
#define YYr43	96
#define YYr42	97
#define YYr41	98
#define YYr38	99
#define YYr37	100
#define YYr35	101
#define YYr33	102
#define YYr32	103
#define YYr31	104
#define YYr30	105
#define YYr29	106
#define YYr28	107
#define YYr27	108
#define YYr26	109
#define YYr25	110
#define YYr24	111
#define YYr23	112
#define YYr22	113
#define YYr21	114
#define YYr20	115
#define YYr19	116
#define YYr16	117
#define YYr6	118
#define YYr5	119
#define YYr4	120
#define YYr3	121
#define YYr2	122
#define YYr1	123
#define YYrACCEPT	YYr131
#define YYrERROR	YYr132
#define YYrLR2	YYr133
#if YYDEBUG
char * yysvar[] = {
	"$accept",
	"operand",
	"reelle_zahl",
	"produkt",
	"ausdruck",
	"boolean",
	"vergleich",
	"zuweisung",
	"ausdruck_opt",
	"summand",
	"func_call",
	"lokale_var",
	"ausgabe",
	"else_opt",
	"anweisung",
	"anweisung2",
	"verzweigung",
	"schleifen",
	"variablen_def",
	"exit",
	"anweisungs_block",
	"while",
	"do_while",
	"return",
	"argument",
	"anweisungen_opt",
	"anweisungen",
	"func_calling",
	"var_def_list",
	"var_def_list_elem",
	"print_arg_liste_opt",
	"arg_liste_opt",
	"arg_liste",
	"func_arg_liste_opt",
	"func_arg_liste",
	"func_var_def",
	"var_typ",
	"func_return_type_opt",
	"func_return_type",
	"inhalt",
	"erster_pass",
	"$1",
	"zweiter_pass",
	"$3",
	"func_locations_opt",
	"$5",
	"$6",
	"func_def_list_opt",
	"func_def_list",
	"func_def",
	"func_locations",
	"func_location",
	"$31",
	"$33",
	"$35",
	"global_save",
	"$54",
	"$55",
	"$58",
	"$62",
	"$64",
	"$68",
	"$70",
	"$71",
	0
};
short yyrmap[] = {

	 131,  132,  133,   17,   18,   34,   36,   39,   40,   47, 
	  48,   49,   50,   53,   57,   67,   73,   74,   78,   82, 
	  83,   88,   89,   90,   91,   92,   93,   94,   95,   96, 
	  97,   98,   99,  100,  125,  129,  130,  128,  127,  126, 
	 124,  123,  122,  121,  120,  119,  118,  117,  116,  115, 
	 114,  113,  112,  111,  110,  109,  108,  107,  106,  105, 
	 104,  103,  102,  101,   87,   86,   85,   84,   81,   80, 
	  79,   77,   76,   75,   72,   71,   70,   69,   68,   66, 
	  65,   64,   63,   62,   61,   60,   59,   58,   56,   55, 
	  54,   52,   51,   46,   45,   44,   43,   42,   41,   38, 
	  37,   35,   33,   32,   31,   30,   29,   28,   27,   26, 
	  25,   24,   23,   22,   21,   20,   19,   16,    6,    5, 
	   4,    3,    2,    1,    7,   10,   11,   14,   15,   13, 
	  12,    9,    8,    0
};
short yysmap[] = {

	   3,    4,    8,   20,   23,   45,   50,   51,   52,   53, 
	  78,   84,  118,  124,  131,  139,  140,  141,  142,  143, 
	 144,  145,  146,  147,  148,  151,  152,  157,  159,  161, 
	 162,  165,  169,  171,  173,  180,  192,  194,  195,  196, 
	 202,  206,  211,  214,  216,  226,  227,  230,  229,  220, 
	 218,  215,  213,  208,  207,  204,  198,  193,  191,  189, 
	 188,  186,  182,  179,  178,  175,  174,  170,  168,  167, 
	 166,  163,  158,  156,  155,  154,  150,  135,  133,  125, 
	 123,  121,  120,  119,  116,  114,  113,  112,  111,  110, 
	 109,  108,  107,  106,  105,  104,  103,  102,  101,  100, 
	  99,   98,   85,   82,   73,   72,   71,   70,   67,   64, 
	  59,   58,   55,   43,   38,   37,   36,   35,   34,   33, 
	  32,   31,   30,   29,   28,   27,   26,   24,   22,   21, 
	  18,   17,   15,   12,   10,    9,    6,    5,    0,  187, 
	  80,   81,  132,   83,   25,  134,   86,   87,   88,   89, 
	  90,   91,   92,   93,   94,   95,   96,   97,   39,   40, 
	  41,   42,  201,  136,  137,  138,   44,   46,   47,   48, 
	  49,  149,  224,  219,  212,  217,  205,  231,  225,  153, 
	 190,  115,  117,  221,   54,  209,  176,   56,   57,  228, 
	 222,  223,  210,  177,  203,  172,  197,   60,   61,   62, 
	  63,  181,  199,  160,  122,   65,  183,   66,  184,   68, 
	  69,  126,  127,  128,  129,   74,   75,   76,  130,   77, 
	  16,   79,   19,   14,    1,   11,    2,  200,  164,  185, 
	   7,   13
};
int yy_parse::yyntoken = 60;
int yy_parse::yynvar = 64;
int yy_parse::yynstate = 232;
int yy_parse::yynrule = 134;
#endif



// C++ YACC parser code
// Copyright 1991 by Mortice Kern Systems Inc.  All rights reserved.
//
// If YYDEBUG is defined as 1 and yy_parse::yydebug is set to 1,
// yyparse() will print a travelogue of its actions as it reads
// and parses input.
//
// YYSYNC can be defined to cause yyparse() to attempt to always
// hold a lookahead token

const YY_MIN_STATE_NUM = 20;    // not useful to be too small!

#if YYDEBUG
#ifdef YYTRACE
long    * yy_parse::States      = yyStates;
#endif
yyTypedRules * yy_parse::Rules  = yyRules;
yyNamedType * yy_parse::TokenTypes = yyTokenTypes;

#define YY_TRACE(fn) { done = 0; fn(); if (done) YYRETURN(-1); }
#endif

#ifndef __OLD_INTERPRETE__
	const char * yy_parse::CreateErrMsg()
	{
		static char Buffer[200];
		sprintf(Buffer,"File : %s,  Line : %d\n", 
			(const char *)(scan->FileName), scan->yylineno);
		return Buffer;
	}
#endif

// Constructor for yy_parse: user-provided tables
yy_parse::yy_parse(int sz, short * states, YYSTYPE * stack,
					Variablen *ptrVariablen)
#ifdef __OLD_INTERPRETE__
: Vars(ptrVariablen)
#else
: Vars(ptrVariablen), ObjInhalt(Vars)
#endif
{
	mustfree = 0;
	if ((size = sz) < YY_MIN_STATE_NUM
	 || (stateStack = states) == (short *) 0
	 || (valueStack = stack) == (YYSTYPE *) 0) {
		fprintf(stderr,"Bad state/stack given");
		exit(1);
	}
	reset = 1;              // force reset
#if YYDEBUG
	yydebug = 0;
	typeStack = new short[size+1];
	if (typeStack == (short *) 0) {
		fprintf(stderr,"Cannot allocate typeStack");
		exit(1);
	}
#endif
}
// Constructor for yy_parse: allocate tables with new
yy_parse::yy_parse(Variablen *ptrVariablen, int sz)
#ifdef __OLD_INTERPRETE__
: Vars(ptrVariablen)
#else
: Vars(ptrVariablen), ObjInhalt(Vars)
#endif
{
	size = sz;
	reset = 1;              // force reset
	mustfree = 1;           // delete space in deconstructor
#if YYDEBUG
	yydebug = 0;
	typeStack = new short[size+1];
#endif
	stateStack = new short[size+1];
	valueStack = new YYSTYPE[size+1];

	if (stateStack == (short *) 0 || valueStack == (YYSTYPE *) 0
#if YYDEBUG
		|| typeStack == (short *) 0
#endif
		) {
		fprintf(stderr,"Not enough space for parser stacks");
		exit(1);
	}
}
// Destructor for class yy_parse
//      Free up space
yy_parse::~yy_parse()
{
	if (mustfree) {
		delete[] stateStack;		// C++ Semantic Error, corrected by Sven Goethel
		delete[] valueStack;		// C++ Semantic Error, corrected by Sven Goethel
	}
	stateStack = (short *) 0;
#if YYDEBUG
	delete[] typeStack;				// C++ Semantic Error, corrected by Sven Goethel
#endif
}

// The parser proper.
//      Note that this code is reentrant; you can return a value
//      and then resume parsing by recalling yyparse().
//      Call yyreset() before yyparse() if you want a fresh start
int
yy_parse::yyparse(yy_scan* ps)
{
	short   * yyp, * yyq;           // table lookup
	int     yyj;
#if YYDEBUG
	int     yyruletype = 0;
#endif

	if ((scan = ps) == (yy_scan *) 0) {     // scanner
		fprintf(stderr,"No scanner");
		exit(1);
	}

	if (reset) {                    // start new parse
		yynerrs = 0;
		yyerrflag = 0;
		yyps = stateStack;
		yypv = valueStack;
#if YYDEBUG
		yytp = typeStack;
#endif
		yystate = YYS0;
		yyclearin();
		reset = 0;
	} else                  // continue saved parse
		goto yyNext;                    // after action

yyStack:
	if (++yyps > &stateStack[size]) {
		scan->yyerror("Parser stack overflow");
		YYABORT;
	}
	*yyps = yystate;        /* stack current state */
	*++yypv = yyval;        /* ... and value */
#if YYDEBUG
	if (yydebug) {
		*++yytp = yyruletype;   /* ... and type */
		YY_TRACE(yyShowState)
	}
#endif

	/*
	 * Look up next action in action table.
	 */
yyEncore:
#ifdef YYSYNC
	if (yychar < 0) {
		if ((yychar = scan->yylex()) < 0)
			yychar = 0;
		yylval = ::yylval;
#if YYDEBUG
		if (yydebug)
			yyShowRead();   // show new input token
#endif
	}
#endif
	if (yystate >= sizeof yypact/sizeof yypact[0])  /* simple state */
		yyi = yystate - YYDELTA;        /* reduce in any case */
	else {
		if(*(yyp = &yyact[yypact[yystate]]) >= 0) {
			/* Look for a shift on yychar */
#ifndef YYSYNC
			if (yychar < 0) {
				if ((yychar = scan->yylex()) < 0)
					yychar = 0;
				yylval = ::yylval;
#if YYDEBUG
				if (yydebug)
					yyShowRead();   // show new input token
#endif
			}
#endif
			yyq = yyp;
			yyi = yychar;
			while (yyi < *yyp++)
				;
			if (yyi == yyp[-1]) {
				yystate = ~yyq[yyq-yyp];
#if YYDEBUG
				if (yydebug) {
					yyruletype = yyGetType(yychar);
					YY_TRACE(yyShowShift)
				}
#endif
				yyval = yylval;         /* stack value */
				yyclearin();            /* clear token */
				if (yyerrflag)
					yyerrflag--;    /* successful shift */
				goto yyStack;
			}
		}

		/*
		 *      Fell through - take default action
		 */

		if (yystate >= sizeof yydef /sizeof yydef[0])
			goto yyError;
		if ((yyi = yydef[yystate]) < 0)  { /* default == reduce? */

			/* Search exception table */
			yyp = &yyex[~yyi];
#ifndef YYSYNC
			if (yychar < 0) {
				if ((yychar = scan->yylex()) < 0)
					yychar = 0;
				yylval = ::yylval;
#if YYDEBUG
				if (yydebug)
					yyShowRead();   // show new input token
#endif
			}
#endif
			while((yyi = *yyp) >= 0 && yyi != yychar)
				yyp += 2;
			yyi = yyp[1];
		}
	}

	yyj = yyrlen[yyi];

#if YYDEBUG
	if (yydebug) {
		npop = yyj; rule = yyi;
		YY_TRACE(yyShowReduce)
		yytp -= yyj;
	}
#endif
	yyps -= yyj;            /* pop stacks */
	yypvt = yypv;           /* save top */
	yypv -= yyj;
	yyval = yypv[1];        /* default action $ = $1 */
#if YYDEBUG
	if (yydebug)
		yyruletype = yyRules[yyrmap[yyi]].type;
#endif
	switch (yyi) {          /* perform semantic action */
		
case YYr1: {	/* inhalt :  erster_pass */

	                  #ifdef __OLD_INTERPRETE__
	                    // Die Liste der Reihenfolge fuer die angelegten Variablen
	                    // loeschen !!!
	                    Vars.ClearVarDefOrder();
											StopOk=0;
	                  #endif
                  
} break;

case YYr2: {	/* inhalt :  erster_pass $1 zweiter_pass */

	                  #ifdef __OLD_INTERPRETE__
	                    // LOKALE VARIABLEN AUFRAEUMEN !!!!!!!!!!!!!
	                    if(global_save.laenge()>0)
	                    {
	                      fprintf(stderr, "<CALC> WARNING ! global_save wurden nicht alle geloescht !\n");
	                      fprintf(stderr, "<CALC> Loesche verbliebene global_save !\n");
	                      while(global_save.laenge()>0) global_save.loesche(0);
	                    }
	                    if(SprungMarken.laenge()>0)
	                    {
	                      fprintf(stderr, "<CALC> WARNING ! Schleifen-Sprungmarkierungen wurden nicht alle geloescht !\n");
	                      fprintf(stderr, "<CALC> Loesche verbliebene Schleifen-Sprungmarkierungen !\n");
	                      while(SprungMarken.laenge()>0) SprungMarken.loesche(0);
	                    }
	                    if(ReturnListe.laenge()>0)
	                    {
	                      fprintf(stderr, "<CALC> WARNING ! Funktions-ReturnWerte wurden nicht alle entgegengenommen !\n");
	                      fprintf(stderr, "<CALC> Loesche verbliebene ReturnWerte !\n");
	                      while(ReturnListe.laenge()>0) ReturnListe.loesche(0);
	                    }
	                    if(ReturnFlags.laenge()>0)
	                    {
	                      fprintf(stderr, "<CALC> WARNING ! Funktions-ReturnFlags wurden nicht alle entgegengenommen !\n");
	                      fprintf(stderr, "<CALC> Loesche verbliebene ReturnFlags !\n");
	                      while(ReturnFlags.laenge()>0) ReturnFlags.loesche(0);
	                    }
	                    if(ArgListe.laenge()>0)
	                    {
	                      fprintf(stderr, "<CALC> INTERN-WARNING ! ArgumentenListe wurde nicht geloescht !\n");
	                      fprintf(stderr, "<CALC> Loesche ArgumentenListe !\n");
	                      while(ArgListe.laenge()>0) ArgListe.loesche(0);
	                    }
	                    if(BooleanStack.laenge()>0)
	                    {
	                      fprintf(stderr, "<CALC> INTERN-WARNING ! BooleanStack wurde nicht geloescht !\n");
	                      fprintf(stderr, "<CALC> Loesche BooleanStack !\n");
	                      while(BooleanStack.laenge()>0) BooleanStack.loesche(0);
	                    }
	                    // Label loeschen !!!!!
	                    while(LabelLoc.laenge()>0) LabelLoc.loesche(0);
	                    // Die Liste der Reihenfolge fuer die angelegten Variablen
	                    // loeschen !!!
	                    Vars.ClearVarDefOrder();
	                  #else
	                  #endif
                  
} break;

case YYr3: {	/* erster_pass :  T_CALC_START */

									  #ifndef __OLD_INTERPRETE__
										  ObjInhalt.Del();
                    #endif
                  
} break;

case YYr4: {	/* erster_pass :  T_CALC_START $3 func_locations_opt T_CALC_END */

										// 2.Pass vom File-Anfang starten !
										if(scan->yyfseek(0,SEEK_SET)!=0)
										{
											scan->yyerror("<CALC> Input File-Error, 2nd Pass, in front of : %s", scan->yytext);
											YYABORT;
										}
										// die lexikalische Analyse registriert mittels
										// der lokalen Variable PassNo den Pass-Wechsel.
										// Somit werden im 1. Pass und im 2. Pass
										// die entsprechenden / unterschiedlichen
										// TOKEN zurueckgeliefert.
										// PassNo Iteriert immer zwischen diesen beiden
										// Modi.
										scan->yy_reset();
										yyclearin(); // lookahead token loeschen.
										# if YYDEBUG
											printf("<CALC> 1.Pass abgeschlossen\n");
										# endif
                  
} break;

case YYr5: {	/* zweiter_pass :  T_CALC_START '(' T_BEZEICHNER ')' ';' */

	                  #ifdef __OLD_INTERPRETE__
	                    
	                    FalseCase=0;
	                    TrueCase=0;
	                    Level=0;
	                  #endif
                  
} break;

case YYr6: {	/* zweiter_pass :  T_CALC_START '(' T_BEZEICHNER ')' ';' $5 anweisungen_opt */

	                  #ifdef __OLD_INTERPRETE__
											if(Level!=0)
											{
												fprintf(stderr, "<CALC> INTERN-WARNING ! Level nach Programmende != 0\n");
												fprintf(stderr, "<CALC> ( Level = %d ) \n", Level);
											}
											StopOk=1;
										#else
											ObjInhalt.pAnweisungen=yypvt[0]._TYPE_6_;
                    #endif
                  
} break;

case YYr16: {	/* func_location :  T_FUNC_DEF T_BEZEICHNER T_FUNC_DEF_END */

	                  #ifdef __OLD_INTERPRETE__
	                    if(LabelLoc.SetFilePos(yypvt[-1]._VARVAL_.strInhalt, yypvt[-2]._FILEPOS_)<1)
	                    {
	                      scan->yyerror("<CALC> LabelScan error A, in front of : %s", scan->yytext);
	                      YYABORT;
	                    }
	                  #else
										  if(ObjInhalt.funktionen.FunktionenOff)
											  INT_ERR(__LINE__);
										  ObjInhalt.funktionen.Bezeichner.fuegeEin(yypvt[-1]._VARVAL_.strInhalt,
										    ObjInhalt.funktionen.Bezeichner.laenge()
											);
	                  #endif
                  
} break;

case YYr17: {	/* anweisungen_opt :  */
 
										  #ifndef __OLD_INTERPRETE__
										    yyval._TYPE_6_=new Anweisungen();
												if(!yyval._TYPE_6_) INT_ERR(__LINE__);
                      #endif
										
} break;

case YYr18: {	/* anweisungen_opt :  anweisungen */
 
										  #ifndef __OLD_INTERPRETE__
										    yyval._TYPE_6_=yypvt[0]._TYPE_6_; 
                      #endif
										
} break;

case YYr19: {	/* anweisungen :  anweisung */
 
										  #ifndef __OLD_INTERPRETE__
												yyval._TYPE_6_=new Anweisungen;
												if(!yyval._TYPE_6_) INT_ERR(__LINE__);
										    yyval._TYPE_6_->fuegeEin(yypvt[0]._TYPE_4_, yyval._TYPE_6_->laenge());
                      #endif
										
} break;

case YYr20: {	/* anweisungen :  anweisungen anweisung */
 
										  #ifndef __OLD_INTERPRETE__
										    yypvt[-1]._TYPE_6_->fuegeEin(yypvt[0]._TYPE_4_, yypvt[-1]._TYPE_6_->laenge());
										    yyval._TYPE_6_=yypvt[-1]._TYPE_6_;
                      #endif
										
} break;

case YYr21: {	/* anweisung :  anweisung2 */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[0]._TYPE_4_;
										#endif
									
} break;

case YYr22: {	/* anweisung :  verzweigung */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[0]._TYPE_4_;
										#endif
									
} break;

case YYr23: {	/* anweisung :  schleifen */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[0]._TYPE_4_;
										#endif
									
} break;

case YYr24: {	/* anweisung2 :  ausdruck_opt ';' */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=new AusdruckOpt(*yypvt[-1]._TYPE_5_);
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr25: {	/* anweisung2 :  variablen_def ';' */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[-1]._TYPE_4_;
										#endif
									
} break;

case YYr26: {	/* anweisung2 :  ausgabe ';' */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[-1]._TYPE_4_;
										#endif
									
} break;

case YYr27: {	/* anweisung2 :  exit ';' */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[-1]._TYPE_4_;
										#endif
									
} break;

case YYr28: {	/* anweisung2 :  anweisungs_block */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[0]._TYPE_4_;
										#endif
									
} break;

case YYr29: {	/* anweisung2 :  return */
 
										#ifndef __OLD_INTERPRETE__
											yyval._TYPE_4_=yypvt[0]._TYPE_4_;
										#endif
									
} break;

case YYr30: {	/* exit :  T_EXIT '(' ausdruck ')' */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      if(yypvt[-1]._TYPE_5_.Type==STRING)
	                      {
	                        scan->yyerror("<CALC> Fehler Exit-Parameter muss eine Zahl sein !\n in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      if((int)(yypvt[-1]._TYPE_5_.rInhalt)==0) YYACCEPT;
	                      else YYABORT;
	                    }
	                  #else
										  yyval._TYPE_4_=new Exit(*yypvt[-1]._TYPE_5_);
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr31: {	/* anweisungs_block :  '{' */

	                  #ifdef __OLD_INTERPRETE__
											// Eine Verschachtelungstiefe weiter.
											Level++;
											#if YYDEBUG
												printf("<CALC> LEVEL : %d\n", Level);
											#endif
									  #endif
	                
} break;

case YYr32: {	/* anweisungs_block :  '{' $31 anweisungen '}' */

	                 #ifdef __OLD_INTERPRETE__
	                   if ( FalseCase == 0 && TrueCase == 0 )
	                   {
	                     // Nur bei der Ausfuehrung wurden Variablen angelegt !!!
	                     #if YYDEBUG
	                       int i=
	                     #endif
	                     Vars.Loesche(Level);
	                   }
										 // Eine Verschachtelungstiefe zurueck.
										 Level--;

										 #if YYDEBUG
											 printf("<CALC> LEVEL : %d ; Vars. geloescht: %d\n",
												 Level, i );
										 #endif
	                 #else
										 yyval._TYPE_4_=new Block(*yypvt[-1]._TYPE_6_, Vars);
										 if(!yyval._TYPE_4_) INT_ERR(__LINE__);
										 yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                 #endif
                  
} break;

case YYr33: {	/* variablen_def :  var_typ */

	                  #ifdef __OLD_INTERPRETE__
										  // Die Liste der Reihenfolge fuer die angelegten Variablen
										  // loeschen !!!
										  Vars.ClearVarDefOrder();
										#endif
                  
} break;

case YYr34: {	/* variablen_def :  var_typ $33 var_def_list */
 
	                  #ifndef __OLD_INTERPRETE__
									    assert(yypvt[0]._TYPE_8_!=NULL);
									    yyval._TYPE_4_=new VariablenDef(yypvt[-2]._VARTYPE_, *yypvt[0]._TYPE_8_, Vars); 
										  if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
                    #endif
								  
} break;

case YYr35: {	/* variablen_def :  T_GLOBAL var_typ */

	                  #ifdef __OLD_INTERPRETE__
										  global=1;
										  // Die Liste der Reihenfolge fuer die angelegten Variablen
										  // loeschen !!!
										  Vars.ClearVarDefOrder();
									  #endif
                  
} break;

case YYr36: {	/* variablen_def :  T_GLOBAL var_typ $35 var_def_list */

	                   #ifdef __OLD_INTERPRETE__
 										   global=0; 
										 #else
									     assert(yypvt[0]._TYPE_8_!=NULL);
									     yyval._TYPE_4_=new VariablenDef ( yypvt[-2]._VARTYPE_, *yypvt[0]._TYPE_8_, Vars, 
											 										   VariablenDef::T_FORCE_GLOBAL ); 
										   if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											 yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                   #endif
                   
} break;

case YYr37: {	/* var_def_list :  var_def_list_elem */

	                  #ifndef __OLD_INTERPRETE__
											yyval._TYPE_8_=new DeepRefListe<Zuweisung>();
											if(!yyval._TYPE_8_) INT_ERR(__LINE__);
											yyval._TYPE_8_->fuegeEin(yypvt[0]._TYPE_9_);
										#endif
                  
} break;

case YYr38: {	/* var_def_list :  var_def_list ',' var_def_list_elem */

	                  #ifndef __OLD_INTERPRETE__
											yypvt[-2]._TYPE_8_->fuegeEin(yypvt[0]._TYPE_9_, yypvt[-2]._TYPE_8_->laenge());
											yyval._TYPE_8_=yypvt[-2]._TYPE_8_;
										#endif
                  
} break;

case YYr39: {	/* var_def_list_elem :  T_BEZEICHNER */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      VariablenInhalt vi(global==1?0:Level, VarDefType);
	                      if ( !Vars.DefiniereVar(yypvt[0]._VARVAL_.strInhalt.GetStrPtr(), vi) )
	                      {
	                        scan->yyerror("<CALC> VAR Definition-Fehler (Doppelte Def.), in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                    }
	                  #else
										  VariablenInhalt vi(0, VarDefType, 0, NULL);
										  ConstOperand * pCO = new ConstOperand (vi);
											if(!pCO) INT_ERR(__LINE__);
											pCO->SetErrorMsg(CreateErrMsg());
											Produkt * pP = new Produkt (*pCO);
											if(!pP) INT_ERR(__LINE__);
											pP->SetErrorMsg(CreateErrMsg());
											Summand * pS = new Summand ( *pP );
											if(!pS) INT_ERR(__LINE__);
											pS->SetErrorMsg(CreateErrMsg());
											yyval._TYPE_9_ = new Zuweisung ( yypvt[0]._VARVAL_.strInhalt, *pS, Vars ); 
											if(!yyval._TYPE_9_) INT_ERR(__LINE__);
											yyval._TYPE_9_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr40: {	/* var_def_list_elem :  T_BEZEICHNER '=' global_save ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) 
											{
												global=global_save[0];
												global_save.loesche(0);

	                      if( yypvt[0]._TYPE_5_.Type==STRING && VarDefType!=STRING )
	                      {
	                        scan->yyerror("<CALC> VAR Definition-Fehler (Falsche TypenKonversion), in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      yypvt[0]._TYPE_5_.Type=VarDefType;
	                      yypvt[0]._TYPE_5_.Level=(global==1)?0:Level;
	                      if ( !Vars.DefiniereVar(yypvt[-3]._VARVAL_.strInhalt.GetStrPtr(), yypvt[0]._TYPE_5_) )
	                      {
	                        scan->yyerror("<CALC> VAR Definition-Fehler (Doppelte Def.), in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                    }
	                  #else
											yyval._TYPE_9_ = new Zuweisung ( yypvt[-3]._VARVAL_.strInhalt, *yypvt[0]._TYPE_5_, Vars ); 
											if(!yyval._TYPE_9_) INT_ERR(__LINE__);
											yyval._TYPE_9_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr41: {	/* global_save :  */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) 
											{
												global_save.fuegeEin(global); 
												global=0;
											}
										#endif
         				  
} break;

case YYr42: {	/* var_typ :  T_VARTYP_INT */
 yyval._VARTYPE_=VarDefType=yypvt[0]._VARTYPE_; 
} break;

case YYr43: {	/* var_typ :  T_VARTYP_REELL */
 yyval._VARTYPE_=VarDefType=yypvt[0]._VARTYPE_; 
} break;

case YYr44: {	/* var_typ :  T_VARTYP_CHAR */
 yyval._VARTYPE_=VarDefType=yypvt[0]._VARTYPE_; 
} break;

case YYr45: {	/* var_typ :  T_VARTYP_STRING */
 yyval._VARTYPE_=VarDefType=yypvt[0]._VARTYPE_; 
} break;

case YYr46: {	/* ausgabe :  T_PRINTF '(' T_STRING print_arg_liste_opt ')' */

	                  #ifdef __OLD_INTERPRETE__

	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      Print(stdout,yypvt[-2]._VARVAL_.strInhalt.GetStrPtr(), ArgListe);
	                      while(ArgListe.laenge()>0) ArgListe.loesche(0);
	                    }
	                  #else
										  yyval._TYPE_4_=new Ausgabe(yypvt[-2]._VARVAL_.strInhalt, *yypvt[-1]._TYPE_10_);
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr47: {	/* print_arg_liste_opt :  */

									  #ifndef __OLD_INTERPRETE__
								      yyval._TYPE_10_=new DeepRefListe<Ausdruck>();
											if(!yyval._TYPE_10_) INT_ERR(__LINE__);
                    #endif
                  
} break;

case YYr48: {	/* print_arg_liste_opt :  ',' arg_liste */

									  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_10_=yypvt[0]._TYPE_10_;
                    #endif
                  
} break;

case YYr49: {	/* arg_liste_opt :  */

									  #ifndef __OLD_INTERPRETE__
								      yyval._TYPE_10_=new DeepRefListe<Ausdruck>();
											if(!yyval._TYPE_10_) INT_ERR(__LINE__);
                    #endif
                  
} break;

case YYr50: {	/* arg_liste_opt :  arg_liste */

									  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_10_=yypvt[0]._TYPE_10_;
                    #endif
                  
} break;

case YYr51: {	/* arg_liste :  argument */

									  #ifndef __OLD_INTERPRETE__
								      yyval._TYPE_10_=new DeepRefListe<Ausdruck>();
											if(!yyval._TYPE_10_) INT_ERR(__LINE__);
											yyval._TYPE_10_->fuegeEin(yypvt[0]._TYPE_5_);
                    #endif
                  
} break;

case YYr52: {	/* arg_liste :  arg_liste ',' argument */

									  #ifndef __OLD_INTERPRETE__
											yypvt[-2]._TYPE_10_->fuegeEin(yypvt[0]._TYPE_5_, yypvt[-2]._TYPE_10_->laenge());
											yyval._TYPE_10_=yypvt[-2]._TYPE_10_;
                    #endif
                  
} break;

case YYr53: {	/* argument :  ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      ArgListe.fuegeEin(yypvt[0]._TYPE_5_);
	                      ArgListe[0].Level=Level;
	                    }
	                  #else
								      yyval._TYPE_5_=yypvt[0]._TYPE_5_;
	                  #endif
                  
} break;

case YYr54: {	/* verzweigung :  T_IF '(' ausdruck ')' */

	                  #ifdef __OLD_INTERPRETE__
	                    #if YYDEBUG
	                      printf("<CALC> FalseCase : %d ; TrueCase : %d !\n",
	                        FalseCase, TrueCase);
	                    #endif
	                    
	                    
	                    VariablenInhalt vi(Level, yypvt[-1]._TYPE_5_.Type); // NULL-Wertig...
	                    if ( yypvt[-1]._TYPE_5_==vi )
	                    {
	                       #if YYDEBUG
	                         printf("<CALC> ausdruck = FALSE !\n");
	                       #endif
	                       FalseCase++;
	                       BooleanStack.fuegeEin(0);
	                    } else {
	                       #if YYDEBUG
	                         printf("<CALC> ausdruck = TRUE !\n");
	                         if ( FalseCase == 0 && TrueCase == 0 )
	                           printf("<CALC> TRUE Zweig aktiv !\n");
	                         else
	                           printf("<CALC> TRUE Zweig passiv !\n");
	                       #endif
	                      BooleanStack.fuegeEin(1);
	                    }
	                  #endif
                  
} break;

case YYr55: {	/* verzweigung :  T_IF '(' ausdruck ')' $54 anweisung2 */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( !BooleanStack[0] ) FalseCase--;
	                    BooleanVal=BooleanStack[0];
	                    BooleanStack.loesche(0);
	                  #endif
                  
} break;

case YYr56: {	/* verzweigung :  T_IF '(' ausdruck ')' $54 anweisung2 $55 else_opt */

	                  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_4_=new Verzweigung ( *yypvt[-5]._TYPE_5_, *yypvt[-2]._TYPE_4_, *yypvt[0]._TYPE_4_); 
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                  #endif
 									
} break;

case YYr57: {	/* else_opt :  */

	                  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_4_=new AusdruckOpt();
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
                    #endif
									
} break;

case YYr58: {	/* else_opt :  T_ELSE */

	                  #ifdef __OLD_INTERPRETE__
	                    BooleanStack.fuegeEin(BooleanVal);
	                    
	                    
	                    if ( BooleanStack[0] ) {
	                      #if YYDEBUG
	                        printf("<CALC> FALSE Zweig Skipped !\n");
	                      #endif
	                      TrueCase++;
	                    } else {
	                      #if YYDEBUG
	                        if ( FalseCase == 0 && TrueCase == 0 )
	                          printf("<CALC> FALSE Zweig aktiv !\n");
	                        else
	                          printf("<CALC> FALSE Zweig passiv !\n");
	                      #endif
	                    }
	                  #endif
                  
} break;

case YYr59: {	/* else_opt :  T_ELSE $58 anweisung */

	                  #ifdef __OLD_INTERPRETE__
	                    
	                    if ( BooleanStack[0] ) TrueCase--;
	                    BooleanStack.loesche(0);
	                  #else
										  yyval._TYPE_4_=yypvt[0]._TYPE_4_;
	                  #endif
                  
} break;

case YYr60: {	/* schleifen :  while */

	                  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_4_=yypvt[0]._TYPE_4_;
	                  #endif
                  
} break;

case YYr61: {	/* schleifen :  do_while */

	                  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_4_=yypvt[0]._TYPE_4_;
	                  #endif
                  
} break;

case YYr62: {	/* while :  T_WHILE '(' ausdruck ')' */

	                  #ifdef __OLD_INTERPRETE__
	                    SprungMarken.fuegeEin(yypvt[-3]._FILEPOS_);
	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      // WENN BEDINGUNG CA. NULL ( wg. REELL ),
	                      // SO HANDELT ES SICH UM DEN FALSE ZWEIG
	                      // D.H. DIE SCHLEIFE IST BEENDET !!!
	                      VariablenInhalt vi(Level, yypvt[-1]._TYPE_5_.Type); // NULL-Wertig...
	                      if ( yypvt[-1]._TYPE_5_==vi )
	                      {
	                        FalseCase++;
	                        BooleanStack.fuegeEin(0);
	                      } else BooleanStack.fuegeEin(1);
	                    } else {
	                      FalseCase++;
	                      BooleanStack.fuegeEin(0);
	                    }
	                  #endif
                  
} break;

case YYr63: {	/* while :  T_WHILE '(' ausdruck ')' $62 anweisung */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase==0 )
	                    {
	                      
	                      
	                      if ( scan->yyfseek( SprungMarken[0].ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
	                      {
	                        scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      scan->yy_reset();
	                      scan->yylineno=SprungMarken[0].LineNo;
	                      yyclearin(); // lookahead token loeschen.
	                    }
	                    SprungMarken.loesche(0);
	                    if ( !BooleanStack[0] ) FalseCase--;
	                    BooleanStack.loesche(0);
	                  #else
										  yyval._TYPE_4_=new Schleife ( *yypvt[-3]._TYPE_5_, *yypvt[0]._TYPE_4_, Schleife::T_WHILE );
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr64: {	/* do_while :  T_DO */

	                  #ifdef __OLD_INTERPRETE__
	                    SprungMarken.fuegeEin(yypvt[0]._FILEPOS_);
	                  #endif
                  
} break;

case YYr65: {	/* do_while :  T_DO $64 anweisung T_WHILE '(' ausdruck ')' ';' */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) 
											{
	                      VariablenInhalt vi(Level, yypvt[-2]._TYPE_5_.Type); // NULL-Wertig...
	                      if ( yypvt[-2]._TYPE_5_!=vi )
	                      {
	                        
	                        
	                        if ( scan->yyfseek( SprungMarken[0].ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
	                        {
	                          scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
	                          YYABORT;
	                        }
	                        scan->yy_reset();
	                        scan->yylineno=SprungMarken[0].LineNo;
	                        yyclearin(); // lookahead token loeschen.
	                      }
	                    }
	                    SprungMarken.loesche(0);
	                  #else
										  yyval._TYPE_4_=new Schleife ( *yypvt[-2]._TYPE_5_, *yypvt[-5]._TYPE_4_, Schleife::T_DOWHILE );
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr66: {	/* func_call :  func_calling func_def */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      yyval._TYPE_7_=ReturnListe[0];
	                      ReturnListe.loesche(0);
	                      ReturnFlags.loesche(0);
	                    }
	                  #else
										  INT_ERR(__LINE__);
	                  #endif
                  
} break;

case YYr67: {	/* func_call :  func_calling */

	                  #ifdef __OLD_INTERPRETE__
	                    // Ausfuehrung war untersagt, FalseCase TrueCase !!!
	                    yyval._TYPE_7_.Set();
	                  #else
										  yyval._TYPE_7_=yypvt[0]._TYPE_7_;
	                  #endif
                  
} break;

case YYr68: {	/* func_calling :  T_BEZEICHNER '(' */

	                  #ifdef __OLD_INTERPRETE__
											// Level auf Levelnivau der Func-Def-Parameter anheben
											Level++;
	                  #endif
                  
} break;

case YYr69: {	/* func_calling :  T_BEZEICHNER '(' $68 arg_liste_opt ')' */

	                  #ifdef __OLD_INTERPRETE__
											// Level Normalisieren....
											Level--;
	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      // Ruecksprung Merken !!!
	                      SprungMarken.fuegeEin(yypvt[0]._FILEPOS_);
	
	                      FilePosition fPos;
	
	                      if ( !LabelLoc.GetFilePos(yypvt[-4]._VARVAL_.strInhalt, fPos) )
	                      {
	                        scan->yyerror("<CALC> Fehler waehrend des Uebergangs zur Funktionsdefinition,\n in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      
	                      if ( scan->yyfseek( fPos.ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
	                      {
	                        scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      scan->yy_reset();
	                      scan->yylineno=fPos.LineNo;
	                      yyclearin(); // lookahead token loeschen.
	                    } else {
	                      // KEIN func_def !!!!
	                    }
	                    // Die Liste der Reihenfolge fuer die angelegten Variablen
	                    // loeschen !!!
	                    Vars.ClearVarDefOrder();
	                  #else
										  int fidx=
											 ObjInhalt.funktionen.Bezeichner.istElement(yypvt[-4]._VARVAL_.strInhalt);
                      if(fidx<0)
											{ 
												scan->yyerror("<CALC> Aufruf einer undefinierten Funktion namens %s\n",
												  (const char *)(yypvt[-4]._VARVAL_.strInhalt));
												YYABORT;
											}
										  yyval._TYPE_7_=new FuncCall ( ObjInhalt.funktionen, fidx, *yypvt[-1]._TYPE_10_ );
											if(!yyval._TYPE_7_) INT_ERR(__LINE__);
											yyval._TYPE_7_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr70: {	/* func_def :  T_FUNC_DEF T_BEZEICHNER */

	                  #ifdef __OLD_INTERPRETE__

										  if(StopOk) YYACCEPT;

	                    // Sicher
	                    if(FalseCase!=0 || TrueCase!=0)
	                    {
	                      scan->yyerror("<CALC> WARNING ! Unbefugter Bereich !\n");
	                      YYABORT;
	                    }
	                    // Eine Verschachtelungstiefe weiter.
	                    Level++;
	                    #if YYDEBUG
	                      printf("<CALC> LEVEL : %d\n", Level);
	                    #endif
	                  #endif
                  
} break;

case YYr71: {	/* func_def :  T_FUNC_DEF T_BEZEICHNER $70 '(' func_arg_liste_opt ')' func_return_type_opt ';' */

	                  #ifdef __OLD_INTERPRETE__
	                    if(FalseCase!=0 || TrueCase!=0)
	                    {
	                      scan->yyerror("<CALC> WARNING ! Unbefugter Bereich !\n");
	                      YYABORT;
	                    }
	                    // Argumente uebernehmen !!!
	                    if ( !Vars.SetzeWerte(Level, ArgListe) )
	                    {
	                      scan->yyerror("<CALC> Functions Parameter-Fehler, in front of : %s", scan->yytext);
	                      YYABORT;
	                    }
	                    // loeschen !!!!
	                    while(ArgListe.laenge()>0) ArgListe.loesche(0);
	                    // return Variablen erzeugen !!!
	                    // Level hier egal !!!
	                    VariablenInhalt vi(0, yypvt[-1]._VARTYPE_, 0, NULL);
	                    ReturnListe.fuegeEin(vi);
	                    ReturnFlags.fuegeEin(1); 
	                  #endif
                  
} break;

case YYr72: {	/* func_def :  T_FUNC_DEF T_BEZEICHNER $70 '(' func_arg_liste_opt ')' func_return_type_opt ';' $71 anweisungen_opt T_FUNC_DEF_END ';' */

	                  #ifndef __OLD_INTERPRETE__
										  if(ObjInhalt.funktionen.FunktionenOff)
											  INT_ERR(__LINE__);
										  int idx = ObjInhalt.funktionen.Bezeichner.
											  istElement(yypvt[-10]._VARVAL_.strInhalt);
                      // be sure .....
                      assert ( idx >=0 );
											assert ( idx== 
															 ObjInhalt.funktionen.InitVarDefRefListeRefListe.
															 laenge()
 														 );
											assert ( idx==
															 ObjInhalt.funktionen.AnweisungenRefListe.
															 laenge()
 														 );
											assert ( idx==
															 ObjInhalt.funktionen.ReturnValListe.
															 laenge()
 														 );
										  ObjInhalt.funktionen.InitVarDefRefListeRefListe.
											  fuegeEin(yypvt[-7]._TYPE_11_, idx);
										  ObjInhalt.funktionen.AnweisungenRefListe.
											  fuegeEin(yypvt[-2]._TYPE_6_,idx);
    									VariablenInhalt vi (0, INT, 0, NULL);
										  ObjInhalt.funktionen.ReturnValListe.
											  fuegeEin(vi,idx);
										#else
	                    #if YYDEBUG
	                      printf("<CALC> LEVEL : %d ; Vars. geloescht: %d\n",
	                        Level-1, Vars.Loesche(Level) );
	                    #else
	                      Vars.Loesche(Level);
	                    #endif
	
	                    // Eine Verschachtelungstiefe zurueck.
	                    Level--;
	
	                    // RETURN entsorgen
	                    if(ReturnFlags[0]==-1) {
	                      // Anweisungen wieder erlauben
	                      FalseCase--;
	                      
	                      if( ReturnListe[0].Type==NONE && ReturnVal.Type!=NONE )
	                      {
	                        scan->yyerror("<CALC> VAR Funktionswert-Rueckgabe nicht gefragt\n, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      // TypeCasting, ausser STRING -> Zahl ... (INT,REELL,...)
	                      if( ( ReturnVal.Type==STRING && ReturnListe[0].Type!=STRING ) ||
	                          ( ReturnListe[0].Type==STRING && ReturnVal.Type!=STRING )
	                        )
	                      {
	                        scan->yyerror("<CALC> VAR Funktionswert-Typ-Fehler, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      // Zuweisung !!!
	                      ReturnListe[0]=ReturnVal;
	                    } else {
	                      if(ReturnListe[0].Type!=NONE) {
	                        scan->yyerror("<CALC> VAR Funktionswert-Rueckgabe-Fehlt, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                    }
	
	                    if(FalseCase!=0 || TrueCase!=0)
	                    {
	                      scan->yyerror("<CALC> WARNING ! IF-THEN-ELSE Verschachtelungen wurden nicht aufgeloest !\n");
	                      YYABORT;
	                    }
	                    
	                    
	                    if ( scan->yyfseek( SprungMarken[0].ByteNo-scan->yyftell(), SEEK_CUR ) != 0 )
	                    {
	                      scan->yyerror("<CALC> File-Positionierungsfehler, in front of : %s", scan->yytext);
	                      YYABORT;
	                    }
	                    scan->yy_reset();
	                    scan->yylineno=SprungMarken[0].LineNo;
	                    SprungMarken.loesche(0);
	                    yyclearin(); // lookahead token loeschen.
	                  #endif
                  
} break;

case YYr73: {	/* func_arg_liste_opt :  */
 
	                  #ifndef __OLD_INTERPRETE__
									    yyval._TYPE_11_=new DeepRefListe<VariablenDef>();
										  if(!yyval._TYPE_11_) INT_ERR(__LINE__);
										#endif
                  
} break;

case YYr74: {	/* func_arg_liste_opt :  func_arg_liste */
 
	                  #ifndef __OLD_INTERPRETE__
									    yyval._TYPE_11_=yypvt[0]._TYPE_11_; 
										#endif
									
} break;

case YYr75: {	/* func_arg_liste :  func_var_def */
 
	                  #ifndef __OLD_INTERPRETE__
											yyval._TYPE_11_=new DeepRefListe<VariablenDef>();
											if(!yyval._TYPE_11_) INT_ERR(__LINE__);
											yyval._TYPE_11_->fuegeEin(yypvt[0]._TYPE_12_);
										#endif
                  
} break;

case YYr76: {	/* func_arg_liste :  func_arg_liste ',' func_var_def */

	                  #ifndef __OLD_INTERPRETE__
											yypvt[-2]._TYPE_11_->fuegeEin(yypvt[0]._TYPE_12_, yypvt[-2]._TYPE_11_->laenge());
											yyval._TYPE_11_=yypvt[-2]._TYPE_11_;
										#endif
									
} break;

case YYr77: {	/* func_var_def :  var_typ var_def_list_elem */

	                  #ifndef __OLD_INTERPRETE__
										  DeepRefListe<Zuweisung> * pZl = 
										  	new DeepRefListe<Zuweisung>();
 											if(!pZl) INT_ERR(__LINE__);
											pZl->fuegeEin(yypvt[0]._TYPE_9_);
										  yyval._TYPE_12_=new VariablenDef (yypvt[-1]._VARTYPE_, *pZl, Vars);
 											if(!yyval._TYPE_12_) INT_ERR(__LINE__);
											yyval._TYPE_12_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr78: {	/* func_return_type_opt :  */

	                 #ifdef __OLD_INTERPRETE__
 										 yyval._VARTYPE_=NONE; 
									 #else
	                 #endif
                 
} break;

case YYr79: {	/* func_return_type_opt :  func_return_type */

	                  #ifdef __OLD_INTERPRETE__
 											yyval._VARTYPE_=yypvt[0]._VARTYPE_; 
										#else
	                  #endif
                  
} break;

case YYr80: {	/* func_return_type :  ':' var_typ */

	                   #ifdef __OLD_INTERPRETE__
 										   yyval._VARTYPE_=yypvt[0]._VARTYPE_; 
										 #else
	                   #endif
                  
} break;

case YYr81: {	/* return :  T_RETURN ausdruck_opt ';' */

	                  #ifndef __OLD_INTERPRETE__
										  yyval._TYPE_4_=new Return(*yypvt[-1]._TYPE_5_, ObjInhalt.funktionen,
											              ObjInhalt.funktionen.ReturnValListe
																		.laenge());
											if(!yyval._TYPE_4_) INT_ERR(__LINE__);
											yyval._TYPE_4_->SetErrorMsg(CreateErrMsg());
	                  #else
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      if(ReturnFlags.laenge()>0) {
	                        if(ReturnFlags[0]==1) {
	                          ReturnVal=yypvt[-1]._TYPE_5_;
	                          FalseCase++; 
	                          ReturnFlags[0]=-1;
	                        } else {
	                          scan->yyerror("<CALC> 'return' (?) hier nicht erlaubt !!!, in front of : %s", scan->yytext);
	                          YYABORT;
	                        }
	                      } else {
	                        scan->yyerror("<CALC> 'return' (N) hier nicht erlaubt !!!, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                    }
	                  #endif
                  
} break;

case YYr82: {	/* ausdruck_opt :  */

										 #ifdef __OLD_INTERPRETE__
											 yyval._TYPE_5_.Set(); 
										 #else
											 yyval._TYPE_5_=new Ausdruck();
											 if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											 yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
										 #endif
									
} break;

case YYr83: {	/* ausdruck_opt :  ausdruck */

	                   #ifdef __OLD_INTERPRETE__
 										   yyval._TYPE_5_=yypvt[0]._TYPE_5_; 
										 #else
											 yyval._TYPE_5_=yypvt[0]._TYPE_5_;
	                   #endif
                   
} break;

case YYr84: {	/* ausdruck :  summand */
 yyval._TYPE_5_=yypvt[0]._TYPE_5_; 
} break;

case YYr85: {	/* ausdruck :  vergleich */
 yyval._TYPE_5_=yypvt[0]._TYPE_5_; 
} break;

case YYr86: {	/* ausdruck :  zuweisung */
 yyval._TYPE_5_=yypvt[0]._TYPE_5_; 
} break;

case YYr87: {	/* ausdruck :  boolean */
 yyval._TYPE_5_=yypvt[0]._TYPE_5_; 
} break;

case YYr88: {	/* boolean :  ausdruck T_UND ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_&&yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Boolean(*yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Boolean::T_AND);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr89: {	/* boolean :  ausdruck T_ODER ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_||yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Boolean(*yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Boolean::T_OR);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr90: {	/* vergleich :  ausdruck T_GLEICH ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_==yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Vergleich ( *yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Vergleich::T_EQ);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr91: {	/* vergleich :  ausdruck T_GROESSERGLEICH ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_>=yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Vergleich ( *yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Vergleich::T_GE);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr92: {	/* vergleich :  ausdruck T_GROESSER ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_>yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Vergleich ( *yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Vergleich::T_GT);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr93: {	/* vergleich :  ausdruck T_KLEINER ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_<yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Vergleich ( *yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Vergleich::T_LT);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr94: {	/* vergleich :  ausdruck T_KLEINERGLEICH ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_<=yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Vergleich ( *yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Vergleich::T_LE);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr95: {	/* vergleich :  ausdruck T_UNGLEICH ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    yyval._TYPE_5_.Set(INT, Level, yypvt[-2]._TYPE_5_!=yypvt[0]._TYPE_5_, NULL);
	                  #else
										  yyval._TYPE_5_=new Vergleich ( *yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_5_, Vergleich::T_NE);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr96: {	/* zuweisung :  T_BEZEICHNER '=' ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 ) {
	                      if ( !Vars.SetzeWert(Level, yypvt[-2]._VARVAL_.strInhalt.GetStrPtr(), yypvt[0]._TYPE_5_) )
	                      {
	                        scan->yyerror("<CALC> VAR Zugriff Fehler (Falsche TypenKonversion oder Falscher Gueltigkeitbereich),\n in front of : %s Variable : %s",
	                        scan->yytext, yypvt[-2]._VARVAL_.strInhalt.GetStrPtr());
	                        YYABORT;
	                      }
	                    }
	                    yyval._TYPE_5_=yypvt[0]._TYPE_5_;
	                  #else
										  yyval._TYPE_5_=new Zuweisung ( yypvt[-2]._VARVAL_.strInhalt, *yypvt[0]._TYPE_5_, Vars);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr97: {	/* zuweisung :  T_BEZEICHNER '[' ausdruck ']' '=' ausdruck */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      VariablenInhalt vi;
	                      if( !Vars.HoleWert(Level, yypvt[-5]._VARVAL_.strInhalt.GetStrPtr(), vi) )
	                      {
	                        scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      // Nur fuer vi.Type==STRING !!!!!!
	                      if(vi.Type==STRING)
	                      {
	                        if(yypvt[-3]._TYPE_5_.Type!=STRING)
	                        {
	                          (vi.strInhalt.GetStrPtr())[(int)(yypvt[-3]._TYPE_5_.rInhalt)]=(int)(yypvt[0]._TYPE_5_.rInhalt);
	                          if ( !Vars.SetzeWert(Level, yypvt[-5]._VARVAL_.strInhalt.GetStrPtr(), vi) )
	                          {
	                            scan->yyerror("<CALC> VAR Zugriff Fehler (Falsche TypenKonversion oder Falscher Gueltigkeitbereich),\n in front of : %s", scan->yytext);
	                            YYABORT;
	                          }
	                        } else {
	                            scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n in front of : %s", scan->yytext);
	                            YYABORT;
	                        }
	                      } else {
	                          scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Array-Dereferenzierer nur fuer STRINGS !),\n in front of : %s", scan->yytext);
	                          YYABORT;
	                      }
	                    } else yyval._TYPE_5_.Set();
	                  #else
										  yyval._TYPE_5_=new Zuweisung ( yypvt[-5]._VARVAL_.strInhalt, *yypvt[-3]._TYPE_5_, *yypvt[0]._TYPE_5_, Vars);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr98: {	/* summand :  produkt */

	                  #ifdef __OLD_INTERPRETE__
 										  yyval._TYPE_5_=yypvt[0]._TYPE_3_; 
										#else
										  yyval._TYPE_5_=new Summand(*yypvt[0]._TYPE_3_);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr99: {	/* summand :  ausdruck '+' produkt */

	                  #ifdef __OLD_INTERPRETE__
	                      if(yypvt[-2]._TYPE_5_.Type==STRING&&yypvt[0]._TYPE_3_.Type==STRING)
	                      {
	                        yyval._TYPE_5_.Set(STRING, Level, 0, yypvt[-2]._TYPE_5_.strInhalt.GetStrPtr());
	                        yyval._TYPE_5_.strInhalt.StrCat(yypvt[0]._TYPE_3_.strInhalt);
	                      } else yyval._TYPE_5_.Set(yypvt[-2]._TYPE_5_.GetBiggestType(yypvt[0]._TYPE_3_), Level, yypvt[-2]._TYPE_5_.rInhalt+yypvt[0]._TYPE_3_.rInhalt, NULL);
	                  #else
										  yyval._TYPE_5_=new Summand(*yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_3_, Summand::T_ADD);
											if(!yyval._TYPE_5_) INT_ERR(__LINE__);
											yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr100: {	/* summand :  ausdruck '-' produkt */

	                     #ifdef __OLD_INTERPRETE__
 yyval._TYPE_5_.Set(yypvt[-2]._TYPE_5_.GetBiggestType(yypvt[0]._TYPE_3_), Level, yypvt[-2]._TYPE_5_.rInhalt-yypvt[0]._TYPE_3_.rInhalt, NULL); 
 											 #else
										     yyval._TYPE_5_=new Summand(*yypvt[-2]._TYPE_5_, *yypvt[0]._TYPE_3_, Summand::T_SUB);
											   if(!yyval._TYPE_5_) INT_ERR(__LINE__);
												 yyval._TYPE_5_->SetErrorMsg(CreateErrMsg());
	                     #endif
                     
} break;

case YYr101: {	/* produkt :  operand */

										#ifdef __OLD_INTERPRETE__
											yyval._TYPE_3_=yypvt[0]._TYPE_1_; 
										#else
											yyval._TYPE_3_=new Produkt ( *yypvt[0]._TYPE_1_ );
											if(!yyval._TYPE_3_) INT_ERR(__LINE__);
											yyval._TYPE_3_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr102: {	/* produkt :  produkt '*' operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_3_.Set(yypvt[-2]._TYPE_3_.GetBiggestType(yypvt[0]._TYPE_1_), Level, 
															 yypvt[-2]._TYPE_3_.rInhalt*yypvt[0]._TYPE_1_.rInhalt, NULL);
											} else yyval._TYPE_3_.Set();
										#else
											yyval._TYPE_3_=new Produkt ( *yypvt[-2]._TYPE_3_, *yypvt[0]._TYPE_1_, Produkt::T_MUL );
											if(!yyval._TYPE_3_) INT_ERR(__LINE__);
											yyval._TYPE_3_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr103: {	/* produkt :  produkt '/' operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												if(yypvt[0]._TYPE_1_.rInhalt!=0) {
													yyval._TYPE_3_.Set(yypvt[-2]._TYPE_3_.GetBiggestType(yypvt[0]._TYPE_1_), Level, 
																yypvt[-2]._TYPE_3_.rInhalt/yypvt[0]._TYPE_1_.rInhalt, NULL);
												} else {
													scan->yyerror("<CALC> DIVISION durch Null, in front of : %s", scan->yytext);
													YYABORT;
												}
											} else yyval._TYPE_3_.Set();
										#else
											yyval._TYPE_3_=new Produkt ( *yypvt[-2]._TYPE_3_, *yypvt[0]._TYPE_1_, Produkt::T_DIV );
											if(!yyval._TYPE_3_) INT_ERR(__LINE__);
											yyval._TYPE_3_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr104: {	/* produkt :  produkt '^' operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_3_.Set(yypvt[-2]._TYPE_3_.GetBiggestType(yypvt[0]._TYPE_1_), Level, 
												 			 pow(yypvt[-2]._TYPE_3_.rInhalt,yypvt[0]._TYPE_1_.rInhalt), NULL);
											} else yyval._TYPE_3_.Set();
										#else
											yyval._TYPE_3_=new Produkt ( *yypvt[-2]._TYPE_3_, *yypvt[0]._TYPE_1_, Produkt::T_POW );
											if(!yyval._TYPE_3_) INT_ERR(__LINE__);
											yyval._TYPE_3_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr105: {	/* produkt :  T_POW '(' ausdruck ',' ausdruck ')' */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      if(yypvt[-3]._TYPE_5_.Type==STRING||yypvt[-1]._TYPE_5_.Type==STRING)
	                      {
	                        scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      yyval._TYPE_3_.Set(yypvt[-3]._TYPE_5_.GetBiggestType(yypvt[-1]._TYPE_5_), Level, 
															 pow(yypvt[-3]._TYPE_5_.rInhalt,yypvt[-1]._TYPE_5_.rInhalt), NULL);
	                    } else yyval._TYPE_3_.Set();
	                  #else
											yyval._TYPE_3_=new Produkt ( *yypvt[-3]._TYPE_5_, *yypvt[-1]._TYPE_5_, Produkt::T_POW );
											if(!yyval._TYPE_3_) INT_ERR(__LINE__);
											yyval._TYPE_3_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr106: {	/* operand :  reelle_zahl */

	                  #ifdef __OLD_INTERPRETE__
 										  yyval._TYPE_1_=yypvt[0]._TYPE_2_; 
									  #else
										  yyval._TYPE_1_=new ConstOperand ( yypvt[0]._TYPE_2_ );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr107: {	/* operand :  T_STRING */

	                  #ifdef __OLD_INTERPRETE__
 										  yyval._TYPE_1_=yypvt[0]._VARVAL_; 
									  #else
										  yyval._TYPE_1_=new ConstOperand ( yypvt[0]._VARVAL_ );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr108: {	/* operand :  func_call */
 yyval._TYPE_1_=yypvt[0]._TYPE_7_; 
} break;

case YYr109: {	/* operand :  lokale_var */
 yyval._TYPE_1_=yypvt[0]._TYPE_7_; 
} break;

case YYr110: {	/* operand :  T_SIN operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=sin(yyval._TYPE_1_.rInhalt);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_SIN );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr111: {	/* operand :  T_COS operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=cos(yyval._TYPE_1_.rInhalt);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_COS );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr112: {	/* operand :  T_TAN operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=tan(yyval._TYPE_1_.rInhalt);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_TAN );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr113: {	/* operand :  T_ARCSIN operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_1_=yypvt[0]._TYPE_1_;
												yyval._TYPE_1_.rInhalt=asin(yyval._TYPE_1_.rInhalt);
											} else yyval._TYPE_1_.Set();
										#else
										  yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_ARCSIN );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr114: {	/* operand :  T_ARCCOS operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_1_=yypvt[0]._TYPE_1_;
												yyval._TYPE_1_.rInhalt=acos(yyval._TYPE_1_.rInhalt);
											} else yyval._TYPE_1_.Set();
										#else
										  yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_ARCCOS );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr115: {	/* operand :  T_ARCTAN operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_1_=yypvt[0]._TYPE_1_;
												yyval._TYPE_1_.rInhalt=atan(yyval._TYPE_1_.rInhalt);
											} else yyval._TYPE_1_.Set();
										#else
										  yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_ARCTAN );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr116: {	/* operand :  T_LOG operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=log(yyval._TYPE_1_.rInhalt);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_LN );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr117: {	/* operand :  T_LOG10 operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=log10(yyval._TYPE_1_.rInhalt);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_LOG );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr118: {	/* operand :  T_EXP operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=exp(yyval._TYPE_1_.rInhalt);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_EXP );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr119: {	/* operand :  T_SQRT operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_1_=yypvt[0]._TYPE_1_;
												yyval._TYPE_1_.rInhalt=sqrt(yyval._TYPE_1_.rInhalt);
											} else yyval._TYPE_1_.Set();
										#else
										  yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_SQRT );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr120: {	/* operand :  T_NEG operand */

										 #ifdef __OLD_INTERPRETE__
												if ( FalseCase == 0 && TrueCase == 0 )
												{
													yyval._TYPE_1_=yypvt[0]._TYPE_1_;
													yyval._TYPE_1_.rInhalt=yyval._TYPE_1_.rInhalt*(-1);
												} else yyval._TYPE_1_.Set();
										 #else
										   yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_NEG );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									 
} break;

case YYr121: {	/* operand :  T_ABS operand */

										#ifdef __OLD_INTERPRETE__
											if ( FalseCase == 0 && TrueCase == 0 )
											{
												yyval._TYPE_1_=yypvt[0]._TYPE_1_;
												yyval._TYPE_1_.rInhalt=fabs(yyval._TYPE_1_.rInhalt);
											} else yyval._TYPE_1_.Set();
										#else
										  yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_ABS );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										#endif
									
} break;

case YYr122: {	/* operand :  '(' ausdruck ')' */

										 #ifdef __OLD_INTERPRETE__
											 yyval._TYPE_1_=yypvt[-1]._TYPE_5_; 
										 #else
										   yyval._TYPE_1_=new AusdruckOperand ( *yypvt[-1]._TYPE_5_ );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									
} break;

case YYr123: {	/* operand :  T_ANYCHAR */

										 #ifdef __OLD_INTERPRETE__
											 yyval._TYPE_1_=yypvt[0]._VARVAL_; 
										 #else
										   yyval._TYPE_1_=new ConstOperand ( yypvt[0]._VARVAL_ );
											 if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											 yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
										 #endif
									
} break;

case YYr124: {	/* operand :  '!' operand */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      VariablenInhalt vi(Level, yypvt[0]._TYPE_1_.Type); // NULL Wertig !
	                      yyval._TYPE_1_.Set(INT, Level, yypvt[0]._TYPE_1_==vi, NULL);
	                    } else yyval._TYPE_1_.Set();
	                  #else
										  yyval._TYPE_1_=new MathOperand ( *yypvt[0]._TYPE_1_, MathOperand::T_NOT );
											if(!yyval._TYPE_1_) INT_ERR(__LINE__);
											yyval._TYPE_1_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr125: {	/* reelle_zahl :  T_ZAHL */
 yyval._TYPE_2_=yypvt[0]._VARVAL_; 
} break;

case YYr126: {	/* reelle_zahl :  T_ZAHL ':' T_ZAHL */

	                  #ifdef __OLD_INTERPRETE__
	                    
	                    yyval._TYPE_2_.Set(REELL, Level, yypvt[-2]._VARVAL_.rInhalt*3600+yypvt[0]._VARVAL_.rInhalt*60, NULL);
	                  #else
	                    
	                    yyval._TYPE_2_.Set(REELL, 0, yypvt[-2]._VARVAL_.rInhalt*3600+yypvt[0]._VARVAL_.rInhalt*60, NULL);
	                  #endif
                  
} break;

case YYr127: {	/* reelle_zahl :  '+' T_ZAHL */
 yyval._TYPE_2_=yypvt[0]._VARVAL_; 
} break;

case YYr128: {	/* reelle_zahl :  '-' T_ZAHL */
 yyval._TYPE_2_=yypvt[0]._VARVAL_; yyval._TYPE_2_.rInhalt*=-1; 
} break;

case YYr129: {	/* lokale_var :  T_BEZEICHNER */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      if(!Vars.HoleWert(Level, yypvt[0]._VARVAL_.strInhalt.GetStrPtr(), yyval._TYPE_7_))
	                      {
	                        scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler, in front of : %s, Variable %s",
	                        scan->yytext, yypvt[0]._VARVAL_.strInhalt.GetStrPtr());
	                        YYABORT;
	                      }
	                    } else yyval._TYPE_7_.Set();
	                  #else
										  yyval._TYPE_7_=new VarOperand ( yypvt[0]._VARVAL_.strInhalt, Vars );
											if(!yyval._TYPE_7_) INT_ERR(__LINE__);
											yyval._TYPE_7_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;

case YYr130: {	/* lokale_var :  T_BEZEICHNER '[' ausdruck ']' */

	                  #ifdef __OLD_INTERPRETE__
	                    if ( FalseCase == 0 && TrueCase == 0 )
	                    {
	                      VariablenInhalt vi;
	                      if(!Vars.HoleWert(Level, yypvt[-3]._VARVAL_.strInhalt.GetStrPtr(), vi))
	                      {
	                        scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler, in front of : %s", scan->yytext);
	                        YYABORT;
	                      }
	                      // Nur fuer vi.Type==STRING !!!!!!
	                      if(vi.Type==STRING)
	                      {
	                        if(yypvt[-1]._TYPE_5_.Type!=STRING)
	                        {
	                          yyval._TYPE_7_.Set(CHAR, Level, (double) ( (vi.strInhalt.GetStrPtr()) [(int)(yypvt[-1]._TYPE_5_.rInhalt)] ) );
	                        } else {
	                            scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n in front of : %s", scan->yytext);
	                            YYABORT;
	                        }
	                      } else {
	                          scan->yyerror("<CALC> LOKALE-VAR Zugriff Fehler (Array-Dereferenzierer nur fuer STRINGS !),\n in front of : %s", scan->yytext);
	                          YYABORT;
	                      }
	                    } else yyval._TYPE_7_.Set();
	                  #else
										  yyval._TYPE_7_=new VarOperand ( yypvt[-3]._VARVAL_.strInhalt, *yypvt[-1]._TYPE_5_, Vars );
											if(!yyval._TYPE_7_) INT_ERR(__LINE__);
											yyval._TYPE_7_->SetErrorMsg(CreateErrMsg());
	                  #endif
                  
} break;
	case YYrACCEPT:
		YYACCEPT;
	case YYrERROR:
		goto yyError;
	}
yyNext:
	/*
	 *      Look up next state in goto table.
	 */

	yyp = &yygo[yypgo[yyi]];
	yyq = yyp++;
	yyi = *yyps;
	while (yyi < *yyp++)            /* busy little loop */
		;
	yystate = ~(yyi == *--yyp? yyq[yyq-yyp]: *yyq);
#if YYDEBUG
	if (yydebug)
		YY_TRACE(yyShowGoto)
#endif
	goto yyStack;

yyerrlabel:     ;               /* come here from YYERROR       */
	yyerrflag = 1;
	if (yyi == YYrERROR) {
		yyps--, yypv--;
#if YYDEBUG
		if (yydebug) yytp--;
#endif
	}
	
yyError:
	switch (yyerrflag) {

	case 0:         /* new error */
		yynerrs++;
		yyi = yychar;
		scan->yyerror("Syntax error");
		if (yyi != yychar) {
			/* user has changed the current token */
			/* try again */
			yyerrflag++;    /* avoid loops */
			goto yyEncore;
		}

	case 1:         /* partially recovered */
	case 2:
		yyerrflag = 3;  /* need 3 valid shifts to recover */
			
		/*
		 *      Pop states, looking for a
		 *      shift on `error'.
		 */

		for ( ; yyps > stateStack; yyps--, yypv--
#if YYDEBUG
					, yytp--
#endif
		) {
			if (*yyps >= sizeof yypact/sizeof yypact[0])
				continue;
			yyp = &yyact[yypact[*yyps]];
			yyq = yyp;
			do
				;
			while (YYERRCODE < *yyp++);
			if (YYERRCODE == yyp[-1]) {
				yystate = ~yyq[yyq-yyp];
				goto yyStack;
			}
				
			/* no shift in this state */
#if YYDEBUG
			if (yydebug && yyps > stateStack+1)
				YY_TRACE(yyShowErrRecovery)
#endif
			/* pop stacks; try again */
		}
		/* no shift on error - abort */
		break;

	case 3:
		/*
		 *      Erroneous token after
		 *      an error - discard it.
		 */

		if (yychar == 0)  /* but not EOF */
			break;
#if YYDEBUG
		if (yydebug)
			YY_TRACE(yyShowErrDiscard)
#endif
		yyclearin();
		goto yyEncore;  /* try again in same state */
	}
	YYABORT;

}
#if YYDEBUG
/*
 * Return type of token
 */
int
yy_parse::yyGetType(int tok)
{
	yyNamedType * tp;
	for (tp = &yyTokenTypes[yyntoken-1]; tp > yyTokenTypes; tp--)
		if (tp->token == tok)
			return tp->type;
	return 0;
}

	
// Print a token legibly.
char *
yy_parse::yyptok(int tok)
{
	yyNamedType * tp;
	for (tp = &yyTokenTypes[yyntoken-1]; tp > yyTokenTypes; tp--)
		if (tp->token == tok)
			return tp->name;
	return "";
}
/*
 * Read state 'num' from YYStatesFile
 */
#ifdef YYTRACE
static FILE *yyStatesFile = (FILE *) 0;
static char yyReadBuf[YYMAX_READ+1];

char *
yy_parse::yygetState(int num)
{
	int     size;
	char    *cp;

	if (yyStatesFile == (FILE *) 0
	 && (yyStatesFile = fopen(YYStatesFile, "r")) == (FILE *) 0)
		return "yyExpandName: cannot open states file";

	if (num < yynstate - 1)
		size = (int)(States[num+1] - States[num]);
	else {
		/* length of last item is length of file - ptr(last-1) */
		if (fseek(yyStatesFile, 0L, 2) < 0)
			goto cannot_seek;
		size = (int) (ftell(yyStatesFile) - States[num]);
	}
	if (size < 0 || size > YYMAX_READ)
		return "yyExpandName: bad read size";
	if (fseek(yyStatesFile, States[num], 0) < 0) {
	cannot_seek:
		return "yyExpandName: cannot seek in states file";
	}

	(void) fread(yyReadBuf, 1, size, yyStatesFile);
	yyReadBuf[size] = '\0';
	return yyReadBuf;
}
#endif /* YYTRACE */
/*
 * Expand encoded string into printable representation
 * Used to decode yyStates and yyRules strings.
 * If the expansion of 's' fits in 'buf', return 1; otherwise, 0.
 */
int
yy_parse::yyExpandName(int num, int isrule, char * buf, int len)
{
	int     i, n, cnt, type;
	char    * endp, * cp, * s;

	if (isrule)
		s = yyRules[num].name;
	else
#ifdef YYTRACE
		s = yygetState(num);
#else
		s = "*no states*";
#endif

	for (endp = buf + len - 8; *s; s++) {
		if (buf >= endp) {              /* too large: return 0 */
		full:   (void) strcpy(buf, " ...\n");
			return 0;
		} else if (*s == '%') {         /* nonterminal */
			type = 0;
			cnt = yynvar;
			goto getN;
		} else if (*s == '&') {         /* terminal */
			type = 1;
			cnt = yyntoken;
		getN:
			if (cnt < 100)
				i = 2;
			else if (cnt < 1000)
				i = 3;
			else
				i = 4;
			for (n = 0; i-- > 0; )
				n = (n * 10) + *++s - '0';
			if (type == 0) {
				if (n >= yynvar)
					goto too_big;
				cp = yysvar[n];
			} else if (n >= yyntoken) {
			    too_big:
				cp = "<range err>";
			} else
				cp = yyTokenTypes[n].name;

			if ((i = strlen(cp)) + buf > endp)
				goto full;
			(void) strcpy(buf, cp);
			buf += i;
		} else
			*buf++ = *s;
	}
	*buf = '\0';
	return 1;
}
#ifndef YYTRACE
/*
 * Show current state of yyparse
 */
void
yy_parse::yyShowState()
{
	(void) printf("state %d (%d), char %s (%d)\n%d stateStack entries\n",
		yysmap[yystate],yystate,yyptok(yychar),yychar,
		yypv - valueStack);
}
// show results of reduction: yyi is rule number
void
yy_parse::yyShowReduce()
{
	(void) printf("Reduce by rule %d (pop#=%d)\n", yyrmap[rule], npop);
}
// show read token
void
yy_parse::yyShowRead()
{
	(void) printf("read %s (%d)\n", yyptok(yychar), yychar);
}
// show Goto
void
yy_parse::yyShowGoto()
{
	(void) printf("goto %d (%d)\n", yysmap[yystate], yystate);
}
// show Shift
void
yy_parse::yyShowShift()
{
	(void) printf("shift %d (%d)\n", yysmap[yystate], yystate);
}
// show error recovery
void
yy_parse::yyShowErrRecovery()
{
	(void) printf("Error recovery pops state %d (%d), uncovers %d (%d)\n",
		yysmap[*(yyps-1)], *(yyps-1), yysmap[yystate], yystate);
}
// show token discards in error processing
void
yy_parse::yyShowErrDiscard()
{
	(void) printf("Error recovery discards %s (%d), ",
		yyptok(yychar), yychar);
}
#endif  /* ! YYTRACE */
#endif  /* YYDEBUG */

