const T_WHILE = 257;
const T_DO = 258;
const T_CALC_END = 259;
const T_FUNC_DEF = 260;
const T_ZAHL = 261;
const T_STRING = 262;
const T_BEZEICHNER = 263;
const T_ANYCHAR = 264;
const T_VARTYP_INT = 265;
const T_VARTYP_REELL = 266;
const T_VARTYP_CHAR = 267;
const T_VARTYP_STRING = 268;
const T_IF = 269;
const T_ELSE = 270;
const T_PRINTF = 271;
const T_FUNC_DEF_END = 272;
const T_CALC_START = 273;
const T_EXIT = 274;
const T_ERROR = 275;
const T_RETURN = 276;
const T_GLOBAL = 277;
const T_ODER = 278;
const T_UND = 279;
const T_GLEICH = 280;
const T_UNGLEICH = 281;
const T_GROESSER = 282;
const T_GROESSERGLEICH = 283;
const T_KLEINER = 284;
const T_KLEINERGLEICH = 285;
const T_SIN = 286;
const T_COS = 287;
const T_TAN = 288;
const T_ARCSIN = 289;
const T_ARCCOS = 290;
const T_ARCTAN = 291;
const T_POW = 292;
const T_LOG = 293;
const T_LOG10 = 294;
const T_EXP = 295;
const T_SQRT = 296;
const T_NEG = 297;
const T_ABS = 298;
extern YYSTYPE yylval;

// C++ YACC parser header
// Copyright 1991 by Mortice Kern Systems Inc.  All rights reserved.
//
// Erweiterung am 6.7.1994 fuer den Calculator
// Aenderung am 4.8.1994
// Protected-Klassen-Elemente wurden fuer den
// Interpreter eingefuegt. Selbige sind in der Klassendeklaration
// gekennzeichnet !!!
// Ebenfalls wurden die Konstruktoren um zwei Parameter erweitert.
//   - Eine 'Variablen' von vordefinierten Variablen,
//     welche dem Parser zur Verfuegung gestellt werden sollen.
//
// yy_parse => class defining a parsing object
//      yy_parse needs a class yy_scan, which defines the scanner.
// %prefix or option -p xx determines name of this class; if not used,
// defaults to 'yy_scan'
//
// constructor fills in the tables for this grammar; give it a size
//    to determine size of state and value stacks. Default is 150 entries.
// destructor discards those state and value stacks
//
// int yy_parse::yyparse(yy_scan *) invokes parse; if this returns,
//      it can be recalled to continue parsing at last point.
// void yy_parse::yyreset() can be called to reset the parse;
//      call yyreset() before yy_parse::yyparse(yy_scan *)
/*
 *
 *  * Revision 2.24  1995/04/07 11:35:09  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:38  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:06:16  Sven_Goethel_DFP
 * Projekt-Pflege nun mit KornShell-Scripts
 * Revision 2.2  1995/04/05 01:48:17  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 1.2  1994/12/31 00:59:05  Sven_Goethel
 * non virtual for WATCOM
 *
*/
#include <stdio.h>              // uses printf(), et cetera
#include <stdlib.h>             // uses exit()

const YYERRCODE = 256;          // YACC 'error' value

// You can use these macros in your action code
#define YYERROR         goto yyerrlabel
#define YYACCEPT        YYRETURN(0)
#define YYABORT         YYRETURN(1)
#define YYRETURN(val)   return(val)

#if YYDEBUG
typedef struct yyNamedType_tag {        /* Tokens */
	char    * name;         /* printable name */
	short   token;          /* token # */
	short   type;           /* token type */
} yyNamedType;
typedef struct yyTypedRules_tag {       /* Typed rule table */
	char    * name;         /* compressed rule string */
	short   type;           /* rule result type */
} yyTypedRules;
#endif

class yy_parse {
protected:
	int     mustfree;       // set if tables should be deleted
	int     size;           // size of state and value stacks
	int     reset;          // if set, reset state
	short   yyi;            // table index
	short   yystate;        // current state

	short   * stateStack;   // states stack
	YYSTYPE * valueStack;   // values stack
	short   * yyps;         // top of state stack
	YYSTYPE * yypv;         // top of value stack

	YYSTYPE yylval;         // saved yylval
	YYSTYPE yyval;          // $
	YYSTYPE * yypvt;        // $n
	int     yychar;         // current token
	int     yyerrflag;      // error flag
	int     yynerrs;        // error count
#if YYDEBUG
	int     done;           // set from trace to stop parse
	int     rule, npop;     // reduction rule # and length
	short   * typeStack;    // type stack to mirror valueStack[]
	short   * yytp;         // top of type stack
	char    * yygetState(int);      // read 'states.out'
#endif
	// Erweiterung fuer den FxmConverterInterpreter <START> !
	//
	// Lokale Variablen werden verwaltet
	Variablen Vars;
	// Fuer die Variablendefinition, so dass es Definitionslisten gibt...
	// Z.Bsp. real a, b, c; Alle Variablen sind vom Typ 'real'.
	// Dieser Typ wird in VarDefType gemerkt.
	VarType VarDefType;
	#ifdef __OLD_INTERPRETE__
		// Level, die aktuelle Verschachtelungstiefe.
		// Bzw. der Gueltigkeitbereich fuer Variablen.
		// Level=0 ==> Globale Variablen, welche erst bei Programmende
		// des Konverters geloescht werden.
		// Level>0 ==> Lokale Variablen, welche bei Austritt aus dem
		// Gueltigkeitbereich geloescht werden.
		// Start bei Level=0 nach 'FxmConverter'.
		int Level;
	  // Wenn StopOk, so wird yy_parse mit YYACCEPT verlassen !!!!
	  int StopOk; 
		// Ein FILO-SprungmarkenStack fuer die Schleifen und Macros(RETURN).
		Liste<FilePosition> SprungMarken;
		// Falls FalseCase != 0 || TrueCase != 0,
		// so werden die Aktionen nicht ausgefuehrt !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		// Die FALSE & TRUE Bedingungen werden rekursiv hoch und runtergezaehlt !
		int     FalseCase;
		int     TrueCase;
		// Die aufzunehmenden Argumente (Inhalt, Reell und String, sowie Typ)
		// fuer die AusgabeSyntaxRegel und AusgabeRoutine und Funktionsparameter.
		Liste<VariablenInhalt> ArgListe;
		// Stack Fuer die Funktionen ....
		Liste<VariablenInhalt> ReturnListe;
		// Die FilePositionen fuer die verschiedenen MACROS,....
		LabelLocus		  LabelLoc;
		// Handles fuer die Anweisung Return :
		// Nur wenn ReturnFlag>0 ist, so ist die Return-Anweisung zulaessig.
		// Dies ist bei Funktionsaufrufen der Fall.
		// Wurde ReturnFlag auf -1 gesetzt, so wurde diese Anweisung
		// ausgefuehrt und der Wert steht in ReturnVal,
		// FalseCase wurde erhoet um die anweisungen zu skippen !!!!!!!
		Liste<int> ReturnFlags;
		VariablenInhalt ReturnVal;
		// Der OperandTyp wird fuer die Ausgabe benoetigt,
		// da die operanden Regel nur einen Reellen Wert wiedergibt
		// und somit der Variablen-Typ verlorengeht !!!!
		VarType LastOperandType;
		// Hilfsvariable fuer die eventuelle Fortsetzung der IF Syntax,
		// mit der Else Syntax.
		int BooleanVal;
		// Stack um den Booleschen Wert des Ausdruckes zu Merken,
		// fuer Verzweigungen
		Liste<int> BooleanStack;
		// global fuer globale var. definitionen
		int global;
		Liste<int> global_save;
  #else
	  Inhalt ObjInhalt;
		const char *CreateErrMsg();
  #endif
	//
	// Erweiterung fuer den FxmConverterInterpreter <ENDE> !
public:
#if YYDEBUG
	// C++ has trouble with initialized arrays inside classes
	static long * States;           // pointer to yyStates[]
	static yyTypedRules * Rules;    // pointer to yyRules[]
	static yyNamedType * TokenTypes; // pointer to yyTokenTypes[]
	static int      yyntoken;       // number of tokens
	static int      yynvar;         // number of variables (nonterminals)
	static int      yynstate;       // number of YACC-generated states
	static int      yynrule;        // number of rules in grammar

	char*   yyptok(int);            // printable token string
	int     yyExpandName(int, int, char *, int);
						// expand encoded string
	virtual int     yyGetType(int);         // return type of token
	virtual void    yyShowRead();           // see newly read token
	virtual void    yyShowState();          // see state, value stacks
	virtual void    yyShowReduce();         // see reduction
	virtual void    yyShowGoto();           // see goto
	virtual void    yyShowShift();          // see shift
	virtual void    yyShowErrRecovery();    // see error recovery
	virtual void    yyShowErrDiscard();     // see token discard in error
#endif
	yy_scan* scan;                  // pointer to scanner
	int     yydebug;        // if set, tracing if compiled with YYDEBUG=1

	// constructor for this grammar
	yy_parse(Variablen *ptrVariablen=NULL, int = 150);
	yy_parse(int, short *, YYSTYPE *,
			 Variablen *ptrVariablen=NULL);

	virtual ~yy_parse();            // destructor

	int     yyparse(yy_scan * ps);  // parse with given scanner

	void    yyreset() { reset = 1; } // restore state for next yyparse()

	void    setdebug(int y) { yydebug = y; }

// The following are useful in user actions:

	void    yyerrok() { yyerrflag = 0; }    // clear error
	void    yyclearin() { yychar = -1; }    // clear input
	int     YYRECOVERING() { return yyerrflag != 0; }
};
// end of .hpp header

